--[[--
	by ALA @ 163UI
--]]--
----------------------------------------------------------------------------------------------------
local __addon, __private = ...;
local MT = __private.MT;
local CT = __private.CT;
local VT = __private.VT;
local DT = __private.DT;

if CT.TOCVERSION >= 40000 or CT.TOCVERSION < 30400 then
	return;
end
-- if WOW_PROJECT_ID ~= WOW_PROJECT_BURNING_CRUSADE_CLASSIC then
-- 	return;
-- end

----------------------------------------------------------------------------------------------------

DT.MAX_LEVEL = 80;
DT.MAX_NUM_TIER = 11;
DT.MAX_NUM_COL = 4;
DT.MAX_NUM_TALENTS = 44;
DT.CUR_PHASE = 1;
--
DT.ClassSpec = {
	DEATHKNIGHT = {
		398,	--Blood,鲜血
		399,	--Frost,冰霜
		400,	--Unholy,邪恶
	},
	DRUID = {
		283,	--Balance,平衡
		281,	--Feral,野性战斗
		282,	--Restoration,恢复
	},
	HUNTER = {
		361,	--BeastMastery,野兽控制
		363,	--Marksmanship,射击
		362,	--Survival,生存
	},
	MAGE = {
		81,		--Arcane,奥术
		41,		--Fire,火焰
		61,		--Frost,冰霜
	},
	PALADIN = {
		382,	--Holy,神圣
		383,	--Protection,防护
		381,	--Combat,惩戒
	},
	PRIEST = {
		201,	--Discipline,戒律
		202,	--Holy,神圣
		203,	--Shadow,暗影
	},
	ROGUE = {
		182,	--Assassination,刺杀
		181,	--Combat,战斗
		183,	--Subtlety,敏锐
	},
	SHAMAN = {
		261,	--Elemental,元素
		263,	--Enhancement,增强
		262,	--Restoration,恢复
	},
	WARLOCK = {
		302,	--Curses,痛苦
		303,	--Summoning,恶魔学识
		301,	--Destruction,毁灭
	},
	WARRIOR = {
		161,	--Arms,武器
		164,	--Fury,狂怒
		163,	--Protection,防护
	},
};
--
	--	DT.TalentDB
	--1-----2----3---4---------5--------6-------7------8---------9--------10-----------11--------------------12
	--tier, col, id, maxPoint, reqTier, reqCol, reqId, Spell[5], texture, [icon index, req index in TreeTDB, req by index in TreeTDB](calculated after addon loaded)
--
DT.TalentDB = {
	DEATHKNIGHT = {
		[398] = {
			{  0, 0, 1939, 2, nil, nil,  nil, { 48979, 49483,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1945, 3, nil, nil,  nil, { 48997, 49490, 49491,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 2017, 5, nil, nil,  nil, { 49182, 49500, 49501, 55225, 55226, }, 'TEXTURE', },
			{  1, 0, 1938, 5, nil, nil,  nil, { 48978, 49390, 49391, 49392, 49393, }, 'TEXTURE', },
			{  1, 1, 1948, 3, nil, nil,  nil, { 49004, 49508, 49509,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 2217, 2, nil, nil,  nil, { 55107, 55108,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1941, 1, nil, nil,  nil, { 48982,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1943, 5, nil, nil,  nil, { 48987, 49477, 49478, 49479, 49480, }, 'TEXTURE', },
			{  2, 2, 2086, 3, nil, nil,  nil, { 49467, 50033, 50034,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1942, 3,   2,   0, 1941, { 48985, 49488, 49489,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2018, 3, nil, nil,  nil, { 49145, 49495, 49497,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1953, 3, nil, nil,  nil, { 49015, 50154, 55136,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2015, 3, nil, nil,  nil, { 48977, 49394, 49395,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1950, 3, nil, nil,  nil, { 49006, 49526, 50029,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1949, 1, nil, nil,  nil, { 49005,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 1944, 3,   2,   1, 1943, { 48988, 49503, 49504,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 2105, 2, nil, nil,  nil, { 53137, 53138,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1960, 3, nil, nil,  nil, { 49027, 49542, 49543,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1954, 1, nil, nil,  nil, { 49016,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1936, 2, nil, nil,  nil, { 50365, 50371,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2259, 2, nil, nil,  nil, { 62905, 62908,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1955, 3, nil, nil,  nil, { 49018, 49529, 49530,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 2019, 1, nil, nil,  nil, { 55233,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1959, 3, nil, nil,  nil, { 49189, 50149, 50150,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1957, 1, nil, nil,  nil, { 55050,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1958, 3, nil, nil,  nil, { 49023, 49533, 49534,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2034, 5, nil, nil,  nil, { 61154, 61155, 61156, 61157, 61158, }, 'TEXTURE', },
			{ 10, 1, 1961, 1, nil, nil,  nil, { 49028,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[399] = {
			{  0, 0, 2031, 3, nil, nil,  nil, { 49175, 50031, 51456,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2020, 2, nil, nil,  nil, { 49455, 50147,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 1968, 5, nil, nil,  nil, { 49042, 49786, 49787, 49788, 49789, }, 'TEXTURE', },
			{  1, 1, 2035, 2, nil, nil,  nil, { 55061, 55062,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1973, 5, nil, nil,  nil, { 49140, 49661, 49662, 49663, 49664, }, 'TEXTURE', },
			{  1, 3, 2022, 3, nil, nil,  nil, { 49226, 50137, 50138,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2042, 5,   0,   0, 2031, { 50880, 50884, 50885, 50886, 50887, }, 'TEXTURE', },
			{  2, 1, 2215, 1, nil, nil,  nil, { 49039,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 2048, 3, nil, nil,  nil, { 51468, 51472, 51473,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 2044, 5, nil, nil,  nil, { 51123, 51127, 51128, 51129, 51130, }, 'TEXTURE', },
			{  3, 2, 1981, 2, nil, nil,  nil, { 49149, 50115,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1971, 2, nil, nil,  nil, { 49137, 49657,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1990, 3, nil, nil,  nil, { 49186, 51108, 51109,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2030, 3, nil, nil,  nil, { 49471, 49790, 49791,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1980, 1, nil, nil,  nil, { 49796,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 2223, 1,   2,   0, 2042, { 55610,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 1993, 2, nil, nil,  nil, { 49024, 49538,   nil,   nil,   nil, }, 'TEXTURE', },
			-- {  5, 1, 1993, 2, 'ReqTier', 'ReqCol', 1994, { 49024, 49538,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1992, 3, nil, nil,  nil, { 49188, 56822, 59057,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2260, 3, nil, nil,  nil, { 50040, 50041, 50043,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1999, 1, nil, nil,  nil, { 49203,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 2029, 2, nil, nil,  nil, { 50384, 50385,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2284, 3, nil, nil,  nil, { 65661, 66191, 66192,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 2210, 3, nil, nil,  nil, { 54639, 54638, 54637,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1979, 1, nil, nil,  nil, { 51271,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1997, 3, nil, nil,  nil, { 49200, 50151, 50152,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1975, 1, nil, nil,  nil, { 49143,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2040, 3, nil, nil,  nil, { 50187, 50190, 50191,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1998, 5, nil, nil,  nil, { 49202, 50127, 50128, 50129, 50130, }, 'TEXTURE', },
			{ 10, 1, 1989, 1, nil, nil,  nil, { 49184,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[400] = {
			{  0, 0, 2082, 2, nil, nil,  nil, { 51745, 51746,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1932, 3, nil, nil,  nil, { 48962, 49567, 49568,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 2218, 5, nil, nil,  nil, { 55129, 55130, 55131, 55132, 55133, }, 'TEXTURE', },
			{  1, 0, 1963, 2, nil, nil,  nil, { 49036, 49562,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1933, 3, nil, nil,  nil, { 48963, 49564, 49565,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 2025, 2, nil, nil,  nil, { 49588, 49589,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 1934, 3, nil, nil,  nil, { 48965, 49571, 49572,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2008, 3, nil, nil,  nil, { 49013, 55236, 55237,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 2047, 5, nil, nil,  nil, { 51459, 51462, 51463, 51464, 51465, }, 'TEXTURE', },
			{  2, 2, 1985, 1, nil, nil,  nil, { 49158,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 2039, 2, nil, nil,  nil, { 49146, 51267,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2004, 3, nil, nil,  nil, { 49219, 49627, 49628,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2225, 2, nil, nil,  nil, { 55620, 55623,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1996, 1, nil, nil,  nil, { 49194,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 2005, 5, nil, nil,  nil, { 49220, 49633, 49635, 49636, 49638, }, 'TEXTURE', },
			{  4, 2, 2011, 2, nil, nil,  nil, { 49223, 49599,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 2226, 2, nil, nil,  nil, { 55666, 55667,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 2009, 3, nil, nil,  nil, { 49224, 49610, 49611,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 2001, 3, nil, nil,  nil, { 49208, 56834, 56835,   nil,   nil, }, 'TEXTURE', },
			{  5, 3, 1984, 1,   3,   3, 2225, { 52143,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2285, 5, nil, nil,  nil, { 66799, 66814, 66815, 66816, 66817, }, 'TEXTURE', },
			{  6, 1, 2221, 1,   5,   1, 2009, { 51052,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 2013, 2, nil, nil,  nil, { 50391, 50392,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 3, 2085, 1,   5,   3, 1984, { 63560,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1962, 3, nil, nil,  nil, { 49032, 49631, 49632,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 2007, 1, nil, nil,  nil, { 49222,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2003, 3, nil, nil,  nil, { 49217, 49654, 49655,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 2043, 3,   7,   1, 1962, { 51099, 51160, 51161,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2216, 1, nil, nil,  nil, { 55090,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2036, 5, nil, nil,  nil, { 50117, 50118, 50119, 50120, 50121, }, 'TEXTURE', },
			{ 10, 1, 2000, 1, nil, nil,  nil, { 49206,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	DRUID = {
		[283] = {
			{  0, 1,  762, 5, nil, nil,  nil, { 16814, 16815, 16816, 16817, 16818, }, 'TEXTURE', },
			{  0, 2, 2238, 5, nil, nil,  nil, { 57810, 57811, 57812, 57813, 57814, }, 'TEXTURE', },
			{  1, 0,  783, 3, nil, nil,  nil, { 16845, 16846, 16847,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1822, 2, nil, nil,  nil, { 35363, 35364,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,  763, 2, nil, nil,  nil, { 16821, 16822,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  782, 3, nil, nil,  nil, { 16836, 16839, 16840,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  789, 3,   1,   1, 1822, { 16880, 61345, 61346,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 2240, 1,   1,   1, 1822, { 57865,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  764, 2, nil, nil,  nil, { 16819, 16820,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  792, 5, nil, nil,  nil, { 16909, 16910, 16911, 16912, 16913, }, 'TEXTURE', },
			{  3, 2,  784, 3, nil, nil,  nil, { 16850, 16923, 16924,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1782, 3, nil, nil,  nil, { 33589, 33590, 33591,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  788, 1, nil, nil,  nil, {  5570,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2239, 3,   4,   1,  788, { 57849, 57850, 57851,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1784, 3, nil, nil,  nil, { 33597, 33599, 33956,   nil,   nil, }, 'TEXTURE', },
			{  5, 1,  790, 3, nil, nil,  nil, { 16896, 16897, 16899,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1783, 2, nil, nil,  nil, { 33592, 33596,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  793, 1, nil, nil,  nil, { 24858,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1912, 3,   6,   1,  793, { 48384, 48395, 48396,   nil,   nil, }, 'TEXTURE', },
			{  6, 3, 1785, 3, nil, nil,  nil, { 33600, 33601, 33602,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1913, 3,   6,   1,  793, { 48389, 48392, 48393,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1786, 5, nil, nil,  nil, { 33603, 33604, 33605, 33606, 33607, }, 'TEXTURE', },
			{  8, 0, 1924, 3, nil, nil,  nil, { 48516, 48521, 48525,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1923, 1,   6,   1,  793, { 50516,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1787, 1, nil, nil,  nil, { 33831,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 3, 1925, 2, nil, nil,  nil, { 48488, 48514,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1928, 3, nil, nil,  nil, { 48506, 48510, 48511,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 1926, 1, nil, nil,  nil, { 48505,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[281] = {
			{  0, 1,  796, 5, nil, nil,  nil, { 16934, 16935, 16936, 16937, 16938, }, 'TEXTURE', },
			{  0, 2,  795, 5, nil, nil,  nil, { 16858, 16859, 16860, 16861, 16862, }, 'TEXTURE', },
			{  1, 0,  799, 3, nil, nil,  nil, { 16947, 16948, 16949,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  805, 2, nil, nil,  nil, { 16998, 16999,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  794, 3, nil, nil,  nil, { 16929, 16930, 16931,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  807, 2, nil, nil,  nil, { 17002, 24866,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1162, 1, nil, nil,  nil, { 61336,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  798, 3, nil, nil,  nil, { 16942, 16943, 16944,   nil,   nil, }, 'TEXTURE', },
			{  3, 0,  802, 2, nil, nil,  nil, { 16966, 16968,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  803, 3, nil, nil,  nil, { 16972, 16974, 16975,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  801, 2,   2,   2,  798, { 37116, 37117,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1914, 2,   2,   2,  798, { 48409, 48410,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  797, 2, nil, nil,  nil, { 16940, 16941,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  804, 1, nil, nil,  nil, { 49377,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1792, 2, nil, nil,  nil, { 33872, 33873,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 2242, 3, nil, nil,  nil, { 57878, 57880, 57881,   nil,   nil, }, 'TEXTURE', },
			{  5, 1,  808, 5,   3,   1,  803, { 17003, 17004, 17005, 17006, 24894, }, 'TEXTURE', },
			{  5, 2, 1794, 3, nil, nil,  nil, { 33853, 33855, 33856,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  809, 1, nil, nil,  nil, { 17007,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1798, 2,   6,   1,  809, { 34297, 34300,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 3, 1793, 3, nil, nil,  nil, { 33851, 33852, 33957,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2241, 3,   6,   1,  809, { 57873, 57876, 57877,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1795, 3, nil, nil,  nil, { 33859, 33866, 33867,   nil,   nil, }, 'TEXTURE', },
			{  7, 3, 1919, 3, nil, nil,  nil, { 48483, 48484, 48485,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1921, 3, nil, nil,  nil, { 48492, 48494, 48495,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1796, 1,   6,   1,  809, { 33917,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1920, 3,   8,   1, 1796, { 48532, 48489, 48491,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1918, 5, nil, nil,  nil, { 48432, 48433, 48434, 51268, 51269, }, 'TEXTURE', },
			{  9, 2, 2266, 1,   9,   1, 1918, { 63503,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 1927, 1, nil, nil,  nil, { 50334,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[282] = {
			{  0, 0,  821, 2, nil, nil,  nil, { 17050, 17051,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  823, 3, nil, nil,  nil, { 17063, 17065, 17066,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  822, 5, nil, nil,  nil, { 17056, 17058, 17059, 17060, 17061, }, 'TEXTURE', },
			{  1, 0,  824, 5, nil, nil,  nil, { 17069, 17070, 17071, 17072, 17073, }, 'TEXTURE', },
			{  1, 1,  841, 3, nil, nil,  nil, { 17118, 17119, 17120,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  826, 3, nil, nil,  nil, { 16833, 16834, 16835,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  829, 3, nil, nil,  nil, { 17106, 17107, 17108,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  827, 1, nil, nil,  nil, { 16864,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1915, 2,   1,   2,  826, { 48411, 48412,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  843, 5, nil, nil,  nil, { 24968, 24969, 24970, 24971, 24972, }, 'TEXTURE', },
			{  3, 2,  830, 3, nil, nil,  nil, { 17111, 17112, 17113,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  831, 1,   2,   0,  829, { 17116,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  828, 5, nil, nil,  nil, { 17104, 24943, 24944, 24945, 24946, }, 'TEXTURE', },
			{  4, 3,  842, 2, nil, nil,  nil, { 17123, 17124,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1788, 2, nil, nil,  nil, { 33879, 33880,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  825, 5,   3,   2,  830, { 17074, 17075, 17076, 17077, 17078, }, 'TEXTURE', },
			{  6, 0, 1797, 3, nil, nil,  nil, { 34151, 34152, 34153,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  844, 1,   4,   1,  828, { 18562,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1790, 3, nil, nil,  nil, { 33881, 33882, 33883,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1789, 5, nil, nil,  nil, { 33886, 33887, 33888, 33889, 33890, }, 'TEXTURE', },
			{  7, 2, 1922, 3, nil, nil,  nil, { 48496, 48499, 48500,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1929, 3, nil, nil,  nil, { 48539, 48544, 48545,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1791, 1,   7,   1, 1789, { 65139,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1930, 3,   8,   1, 1791, { 48535, 48536, 48537,   nil,   nil, }, 'TEXTURE', },
			{  9, 0, 2264, 2, nil, nil,  nil, { 63410, 63411,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 1916, 5, nil, nil,  nil, { 51179, 51180, 51181, 51182, 51183, }, 'TEXTURE', },
			{ 10, 1, 1917, 1,   8,   1, 1791, { 48438,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	HUNTER = {
		[361] = {
			{  0, 1, 1382, 5, nil, nil,  nil, { 19552, 19553, 19554, 19555, 19556, }, 'TEXTURE', },
			{  0, 2, 1389, 5, nil, nil,  nil, { 19583, 19584, 19585, 19586, 19587, }, 'TEXTURE', },
			{  1, 0, 1624, 2, nil, nil,  nil, { 35029, 35030,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1381, 3, nil, nil,  nil, { 19549, 19550, 19551,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1395, 3, nil, nil,  nil, { 19609, 19610, 19612,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 1625, 2, nil, nil,  nil, { 24443, 19575,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1384, 2, nil, nil,  nil, { 19559, 19560,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 2138, 1, nil, nil,  nil, { 53265,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1396, 5, nil, nil,  nil, { 19616, 19617, 19618, 19619, 19620, }, 'TEXTURE', },
			{  3, 1, 1385, 2, nil, nil,  nil, { 19572, 19573,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1393, 5, nil, nil,  nil, { 19598, 19599, 19600, 19601, 19602, }, 'TEXTURE', },
			{  4, 0, 1388, 2, nil, nil,  nil, { 19578, 20895,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1387, 1, nil, nil,  nil, { 19577,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1390, 2, nil, nil,  nil, { 19590, 19592,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1799, 2, nil, nil,  nil, { 34453, 34454,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1397, 5,   3,   2, 1393, { 19621, 19622, 19623, 19624, 19625, }, 'TEXTURE', },
			{  6, 0, 1800, 3, nil, nil,  nil, { 34455, 34459, 34460,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1386, 1,   4,   1, 1387, { 19574,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1801, 3, nil, nil,  nil, { 34462, 34464, 34465,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2136, 2,   6,   0, 1800, { 53252, 53253,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1802, 5, nil, nil,  nil, { 34466, 34467, 34468, 34469, 34470, }, 'TEXTURE', },
			{  8, 0, 2140, 3, nil, nil,  nil, { 53262, 53263, 53264,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1803, 1,   6,   1, 1386, { 34692,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2137, 3,   7,   2, 1802, { 53256, 53259, 53260,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2227, 5, nil, nil,  nil, { 56314, 56315, 56316, 56317, 56318, }, 'TEXTURE', },
			{ 10, 1, 2139, 1, nil, nil,  nil, { 53270,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[362] = {
			{  0, 0, 1623, 5, nil, nil,  nil, { 52783, 52785, 52786, 52787, 52788, }, 'TEXTURE', },
			{  0, 1, 1820, 3, nil, nil,  nil, { 19498, 19499, 19500,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 1621, 2, nil, nil,  nil, { 19159, 19160,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 1310, 3, nil, nil,  nil, { 19290, 19294, 24283,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1304, 3, nil, nil,  nil, { 19184, 19387, 19388,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1305, 3, nil, nil,  nil, { 19376, 63457, 63458,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 1810, 2, nil, nil,  nil, { 34494, 34496,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1622, 5, nil, nil,  nil, { 19255, 19256, 19257, 19258, 19259, }, 'TEXTURE', },
			{  2, 1, 1814, 1, nil, nil,  nil, { 19503,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1311, 3, nil, nil,  nil, { 19295, 19297, 19298,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 1309, 2, nil, nil,  nil, { 19286, 19287,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 2229, 3, nil, nil,  nil, { 56333, 56336, 56337,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1306, 3, nil, nil,  nil, { 56342, 56343, 56344,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2228, 3,   2,   0, 1622, { 56339, 56340, 56341,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1321, 3, nil, nil,  nil, { 19370, 19371, 19373,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1312, 1,   2,   2, 1311, { 19306,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1303, 5, nil, nil,  nil, { 19168, 19180, 19181, 24296, 24297, }, 'TEXTURE', },
			{  5, 2, 1809, 3, nil, nil,  nil, { 34491, 34492, 34493,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1812, 3,   5,   0, 1303, { 34500, 34502, 34503,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1325, 1,   4,   1, 1321, { 19386,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1811, 3, nil, nil,  nil, { 34497, 34498, 34499,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1813, 5, nil, nil,  nil, { 34506, 34507, 34508, 34838, 34839, }, 'TEXTURE', },
			{  7, 1, 2141, 3,   6,   1, 1325, { 53295, 53296, 53297,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2142, 2, nil, nil,  nil, { 53298, 53299,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1322, 1, nil, nil,  nil, {  3674,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 3, 2143, 3, nil, nil,  nil, { 53302, 53303, 53304,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 2144, 3,   6,   2, 1811, { 53290, 53291, 53292,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 2145, 1,   8,   1, 1322, { 53301,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[363] = {
			{  0, 0, 1341, 2, nil, nil,  nil, { 19407, 19412,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2197, 3, nil, nil,  nil, { 53620, 53621, 53622,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 1344, 5, nil, nil,  nil, { 19426, 19427, 19429, 19430, 19431, }, 'TEXTURE', },
			{  1, 0, 1806, 3, nil, nil,  nil, { 34482, 34483, 34484,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1343, 3, nil, nil,  nil, { 19421, 19422, 19423,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1349, 5, nil, nil,  nil, { 19485, 19487, 19488, 19489, 19490, }, 'TEXTURE', },
			{  2, 0, 1818, 2, nil, nil,  nil, { 34950, 34954,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1346, 3, nil, nil,  nil, { 19454, 19455, 19456,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1345, 1,   1,   2, 1349, { 19434,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 1819, 2, nil, nil,  nil, { 34948, 34949,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 1348, 3, nil, nil,  nil, { 19464, 19465, 19466,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1342, 5, nil, nil,  nil, { 19416, 19417, 19418, 19419, 19420, }, 'TEXTURE', },
			{  4, 0, 1351, 2, nil, nil,  nil, { 35100, 35102,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1353, 1, nil, nil,  nil, { 23989,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1347, 3, nil, nil,  nil, { 19461, 19462, 24691,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1804, 2, nil, nil,  nil, { 34475, 34476,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 3, 1362, 3, nil, nil,  nil, { 19507, 19508, 19509,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2130, 3, nil, nil,  nil, { 53234, 53237, 53238,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1361, 1,   4,   1, 1353, { 19506,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1821, 3,   4,   2, 1347, { 35104, 35110, 35111,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1807, 5, nil, nil,  nil, { 34485, 34486, 34487, 34488, 34489, }, 'TEXTURE', },
			{  7, 2, 2131, 2, nil, nil,  nil, { 53228, 53232,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2132, 3, nil, nil,  nil, { 53215, 53216, 53217,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1808, 1,   7,   1, 1807, { 34490,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2133, 3, nil, nil,  nil, { 53221, 53222, 53224,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2134, 5, nil, nil,  nil, { 53241, 53243, 53244, 53245, 53246, }, 'TEXTURE', },
			{ 10, 1, 2135, 1, nil, nil,  nil, { 53209,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	MAGE = {
		[81] = {
			{  0, 0,   74, 2, nil, nil,  nil, { 11210, 12592,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,   76, 3, nil, nil,  nil, { 11222, 12839, 12840,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,   80, 5, nil, nil,  nil, { 11237, 12463, 12464, 16769, 16770, }, 'TEXTURE', },
			{  1, 0,   85, 3, nil, nil,  nil, { 28574, 54658, 54659,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1650, 2, nil, nil,  nil, { 29441, 29444,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,   75, 5, nil, nil,  nil, { 11213, 12574, 12575, 12576, 12577, }, 'TEXTURE', },
			{  2, 0,   82, 2, nil, nil,  nil, { 11247, 12606,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,   81, 3, nil, nil,  nil, { 11242, 12467, 12469,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1845, 3, nil, nil,  nil, { 44397, 44398, 44399,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 2211, 1, nil, nil,  nil, { 54646,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 0,   83, 2, nil, nil,  nil, { 11252, 12605,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,   88, 2, nil, nil,  nil, { 11255, 12598,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1142, 3, nil, nil,  nil, { 18462, 18463, 18464,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2222, 3, nil, nil,  nil, { 29447, 55339, 55340,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1724, 2, nil, nil,  nil, { 31569, 31570,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,   86, 1, nil, nil,  nil, { 12043,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3,   77, 5, nil, nil,  nil, { 11232, 12500, 12501, 12502, 12503, }, 'TEXTURE', },
			{  5, 0, 1726, 3, nil, nil,  nil, { 31574, 31575, 54354,   nil,   nil, }, 'TEXTURE', },
			{  5, 1,  421, 3,   4,   1,   86, { 15058, 15059, 15060,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1725, 2,   4,   1,   86, { 31571, 31572,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1727, 3, nil, nil,  nil, { 31579, 31582, 31583,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,   87, 1,   5,   1,  421, { 12042,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1844, 3, nil, nil,  nil, { 44394, 44395, 44396,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1843, 2,   6,   1,   87, { 44378, 44379,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1728, 5, nil, nil,  nil, { 31584, 31585, 31586, 31587, 31588, }, 'TEXTURE', },
			{  8, 1, 1729, 1, nil, nil,  nil, { 31589,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2209, 5, nil, nil,  nil, { 44404, 54486, 54488, 54489, 54490, }, 'TEXTURE', },
			{  9, 1, 1846, 3, nil, nil,  nil, { 44400, 44402, 44403,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 1826, 2, nil, nil,  nil, { 35578, 35581,   nil,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 1847, 1, nil, nil,  nil, { 44425,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[41] = {
			{  0, 0,   27, 2, nil, nil,  nil, { 11078, 11080,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1141, 3, nil, nil,  nil, { 18459, 18460, 54734,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,   26, 5, nil, nil,  nil, { 11069, 12338, 12339, 12340, 12341, }, 'TEXTURE', },
			{  1, 0,   34, 5, nil, nil,  nil, { 11119, 11120, 12846, 12847, 12848, }, 'TEXTURE', },
			{  1, 1, 2212, 2, nil, nil,  nil, { 54747, 54749,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,   31, 3, nil, nil,  nil, { 11108, 12349, 12350,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,   28, 2, nil, nil,  nil, { 11100, 12353,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,   30, 3, nil, nil,  nil, { 11103, 12357, 12358,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,   29, 1, nil, nil,  nil, { 11366,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,   23, 2, nil, nil,  nil, { 11083, 12351,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 0,   25, 3, nil, nil,  nil, { 11095, 12872, 12873,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,   24, 2, nil, nil,  nil, { 11094, 13043,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1639, 3, nil, nil,  nil, { 29074, 29075, 29076,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1730, 3, nil, nil,  nil, { 31638, 31639, 31640,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,   33, 3, nil, nil,  nil, { 11115, 11367, 11368,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,   32, 1,   2,   2,   29, { 11113,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1731, 2, nil, nil,  nil, { 31641, 31642,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,   35, 5, nil, nil,  nil, { 11124, 12378, 12398, 12399, 12400, }, 'TEXTURE', },
			{  6, 0, 1733, 3, nil, nil,  nil, { 34293, 34295, 34296,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,   36, 1,   4,   1,   33, { 11129,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1732, 2, nil, nil,  nil, { 31679, 31680,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1848, 2, nil, nil,  nil, { 64353, 64357,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1734, 3, nil, nil,  nil, { 31656, 31657, 31658,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1849, 2,   8,   1, 1735, { 44442, 44443,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1735, 1,   6,   1,   36, { 31661,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1850, 3, nil, nil,  nil, { 44445, 44446, 44448,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1851, 5, nil, nil,  nil, { 44449, 44469, 44470, 44471, 44472, }, 'TEXTURE', },
			{ 10, 1, 1852, 1, nil, nil,  nil, { 44457,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[61] = {
			{  0, 0,   38, 3, nil, nil,  nil, { 11071, 12496, 12497,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,   37, 5, nil, nil,  nil, { 11070, 12473, 16763, 16765, 16766, }, 'TEXTURE', },
			{  0, 2,   62, 3, nil, nil,  nil, { 31670, 31672, 55094,   nil,   nil, }, 'TEXTURE', },
			{  1, 0,   73, 3, nil, nil,  nil, { 11207, 12672, 15047,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,   70, 2, nil, nil,  nil, { 11189, 28332,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1649, 3, nil, nil,  nil, { 29438, 29439, 29440,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,   65, 3, nil, nil,  nil, { 11175, 12569, 12571,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,   61, 3, nil, nil,  nil, { 11151, 12952, 12953,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,   69, 1, nil, nil,  nil, { 12472,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,   63, 3, nil, nil,  nil, { 11185, 12487, 12488,   nil,   nil, }, 'TEXTURE', },
			{  3, 0,  741, 2, nil, nil,  nil, { 16757, 16758,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,   66, 3, nil, nil,  nil, { 11160, 12518, 12519,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,   67, 3, nil, nil,  nil, { 11170, 12982, 12983,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,   72, 1, nil, nil,  nil, { 11958,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,   64, 3, nil, nil,  nil, { 11190, 12489, 12490,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1736, 3, nil, nil,  nil, { 31667, 31668, 31669,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1737, 2,   4,   1,   72, { 55091, 55092,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,   68, 3, nil, nil,  nil, { 11180, 28592, 28593,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2214, 2,   6,   1,   71, { 44745, 54787,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,   71, 1,   4,   1,   72, { 11426,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1738, 5, nil, nil,  nil, { 31674, 31675, 31676, 31677, 31678, }, 'TEXTURE', },
			{  7, 1, 1740, 2, nil, nil,  nil, { 31682, 31683,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1853, 2, nil, nil,  nil, { 44543, 44545,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1854, 3, nil, nil,  nil, { 44546, 44548, 44549,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1741, 1, nil, nil,  nil, { 31687,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1855, 3,   8,   1, 1741, { 44557, 44560, 44561,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1856, 5, nil, nil,  nil, { 44566, 44567, 44568, 44570, 44571, }, 'TEXTURE', },
			{ 10, 1, 1857, 1, nil, nil,  nil, { 44572,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	PALADIN = {
		[382] = {
			{  0, 1, 1432, 5, nil, nil,  nil, { 20205, 20206, 20207, 20209, 20208, }, 'TEXTURE', },
			{  0, 2, 1463, 5, nil, nil,  nil, { 20224, 20225, 20330, 20331, 20332, }, 'TEXTURE', },
			{  1, 0, 1444, 3, nil, nil,  nil, { 20237, 20238, 20239,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1449, 5, nil, nil,  nil, { 20257, 20258, 20259, 20260, 20261, }, 'TEXTURE', },
			{  1, 2, 1628, 2, nil, nil,  nil, {  9453, 25836,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1435, 1, nil, nil,  nil, { 31821,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1461, 5, nil, nil,  nil, { 20210, 20212, 20213, 20214, 20215, }, 'TEXTURE', },
			{  2, 2, 1443, 2, nil, nil,  nil, { 20234, 20235,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1450, 3, nil, nil,  nil, { 20254, 20255, 20256,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1446, 2, nil, nil,  nil, { 20244, 20245,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2198, 2, nil, nil,  nil, { 53660, 53661,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1742, 2, nil, nil,  nil, { 31822, 31823,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1433, 1,   2,   1, 1461, { 20216,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1465, 3, nil, nil,  nil, { 20359, 20360, 20361,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1743, 2, nil, nil,  nil, { 31825, 31826,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1627, 5, nil, nil,  nil, {  5923,  5924,  5925,  5926, 25829, }, 'TEXTURE', },
			{  6, 0, 1745, 3, nil, nil,  nil, { 31833, 31835, 31836,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1502, 1,   4,   1, 1433, { 20473,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1744, 3, nil, nil,  nil, { 31828, 31829, 31830,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2190, 3, nil, nil,  nil, { 53551, 53552, 53553,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1746, 5, nil, nil,  nil, { 31837, 31838, 31839, 31840, 31841, }, 'TEXTURE', },
			{  8, 0, 1747, 1, nil, nil,  nil, { 31842,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2199, 5, nil, nil,  nil, { 53671, 53673, 54151, 54154, 54155, }, 'TEXTURE', },
			{  9, 1, 2193, 2,   6,   1, 1502, { 53569, 53576,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 2191, 2, nil, nil,  nil, { 53556, 53557,   nil,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 2192, 1, nil, nil,  nil, { 53563,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[383] = {
			{  0, 1, 1442, 5, nil, nil,  nil, { 63646, 63647, 63648, 63649, 63650, }, 'TEXTURE', },
			{  0, 2, 2185, 5, nil, nil,  nil, { 20262, 20263, 20264, 20265, 20266, }, 'TEXTURE', },
			{  1, 0, 1748, 3, nil, nil,  nil, { 31844, 31845, 53519,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1425, 2, nil, nil,  nil, { 20174, 20175,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1629, 5, nil, nil,  nil, { 20096, 20097, 20098, 20099, 20100, }, 'TEXTURE', },
			{  2, 0, 2280, 1, nil, nil,  nil, { 64205,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1501, 3, nil, nil,  nil, { 20468, 20469, 20470,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1423, 5, nil, nil,  nil, { 20143, 20144, 20145, 20146, 20147, }, 'TEXTURE', },
			{  3, 0, 2281, 2,   2,   0, 2280, { 53527, 53530,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 1521, 2, nil, nil,  nil, { 20487, 20488,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1422, 3, nil, nil,  nil, { 20138, 20139, 20140,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1431, 1, nil, nil,  nil, { 20911,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1426, 5, nil, nil,  nil, { 20177, 20179, 20181, 20180, 20182, }, 'TEXTURE', },
			{  5, 0, 1750, 2, nil, nil,  nil, { 31848, 31849,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1429, 3, nil, nil,  nil, { 20196, 20197, 20198,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2282, 2, nil, nil,  nil, { 31785, 33776,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1430, 1,   4,   1, 1431, { 20925,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1751, 3, nil, nil,  nil, { 31850, 31851, 31852,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1421, 3, nil, nil,  nil, { 20127, 20130, 20135,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1753, 3, nil, nil,  nil, { 31858, 31859, 31860,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2195, 3, nil, nil,  nil, { 53590, 53591, 53592,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1754, 1,   6,   1, 1430, { 31935,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2194, 2, nil, nil,  nil, { 53583, 53585,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2204, 3,   8,   1, 1754, { 53709, 53710, 53711,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 2200, 2, nil, nil,  nil, { 53695, 53696,   nil,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 2196, 1, nil, nil,  nil, { 53595,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[381] = {
			{  0, 1, 1403, 5, nil, nil,  nil, { 20060, 20061, 20062, 20063, 20064, }, 'TEXTURE', },
			{  0, 2, 1407, 5, nil, nil,  nil, { 20101, 20102, 20103, 20104, 20105, }, 'TEXTURE', },
			{  1, 0, 1631, 2, nil, nil,  nil, { 25956, 25957,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1464, 3, nil, nil,  nil, { 20335, 20336, 20337,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1401, 2, nil, nil,  nil, { 20042, 20045,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1633, 2, nil, nil,  nil, {  9452, 26016,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1411, 5, nil, nil,  nil, { 20117, 20118, 20119, 20120, 20121, }, 'TEXTURE', },
			{  2, 2, 1481, 1, nil, nil,  nil, { 20375,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 1634, 2, nil, nil,  nil, { 26022, 26023,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1632, 2, nil, nil,  nil, {  9799, 25988,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 1761, 3, nil, nil,  nil, { 32043, 35396, 35397,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1755, 3, nil, nil,  nil, { 31866, 31867, 31868,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1410, 3, nil, nil,  nil, { 20111, 20112, 20113,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1756, 1, nil, nil,  nil, { 31869,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			-- {  4, 2, 1756, 1, 'ReqTier', 'ReqCol', 1409, { 31869,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 1402, 3,   2,   1, 1411, { 20049, 20056, 20057,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1757, 2, nil, nil,  nil, { 31871, 31872,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2176, 2, nil, nil,  nil, { 53486, 53488,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1441, 1, nil, nil,  nil, { 20066,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1758, 3, nil, nil,  nil, { 31876, 31877, 31878,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1759, 3,   6,   1, 1441, { 31879, 31880, 31881,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 2147, 2, nil, nil,  nil, { 53375, 53376,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2148, 3, nil, nil,  nil, { 53379, 53484, 53648,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1823, 1, nil, nil,  nil, { 35395,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2179, 3, nil, nil,  nil, { 53501, 53502, 53503,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2149, 3, nil, nil,  nil, { 53380, 53381, 53382,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 2150, 1, nil, nil,  nil, { 53385,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	PRIEST = {
		[203] = {
			{  0, 0,  465, 3, nil, nil,  nil, { 15270, 15335, 15336,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2027, 2,   0,   0,  465, { 15337, 15338,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  462, 5, nil, nil,  nil, { 15259, 15307, 15308, 15309, 15310, }, 'TEXTURE', },
			{  1, 0,  466, 3, nil, nil,  nil, { 15318, 15272, 15320,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  482, 2, nil, nil,  nil, { 15275, 15317,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  463, 3, nil, nil,  nil, { 15260, 15327, 15328,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  542, 2, nil, nil,  nil, { 15392, 15448,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  481, 5, nil, nil,  nil, { 15273, 15312, 15313, 15314, 15316, }, 'TEXTURE', },
			{  2, 2,  501, 1, nil, nil,  nil, { 15407,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  483, 2, nil, nil,  nil, { 15274, 15311,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  881, 2, nil, nil,  nil, { 17322, 17323,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3,  461, 3, nil, nil,  nil, { 15257, 15331, 15332,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  541, 1,   2,   0,  542, { 15487,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  484, 1, nil, nil,  nil, { 15286,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1638, 2,   4,   1,  484, { 27839, 27840,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1777, 3, nil, nil,  nil, { 33213, 33214, 33215,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1781, 2, nil, nil,  nil, { 14910, 33371,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 2267, 3, nil, nil,  nil, { 63625, 63626, 63627,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  521, 1,   4,   1,  484, { 15473,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1778, 5, nil, nil,  nil, { 33221, 33222, 33223, 33224, 33225, }, 'TEXTURE', },
			{  7, 0, 1906, 2,   6,   1,  521, { 47569, 47570,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1816, 3, nil, nil,  nil, { 33191, 33192, 33193,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1908, 1, nil, nil,  nil, { 64044,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1779, 1,   6,   1,  521, { 34914,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1909, 3, nil, nil,  nil, { 47580, 47581, 47582,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 1907, 5, nil, nil,  nil, { 47573, 47577, 47578, 51166, 51167, }, 'TEXTURE', },
			{ 10, 1, 1910, 1,   8,   1, 1779, { 47585,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[202] = {
			{  0, 0,  410, 2, nil, nil,  nil, { 14913, 15012,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  406, 3, nil, nil,  nil, { 14908, 15020, 17191,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  401, 5, nil, nil,  nil, { 14889, 15008, 15009, 15010, 15011, }, 'TEXTURE', },
			{  1, 1,  411, 5, nil, nil,  nil, { 27900, 27901, 27902, 27903, 27904, }, 'TEXTURE', },
			{  1, 2, 1181, 5, nil, nil,  nil, { 18530, 18531, 18533, 18534, 18535, }, 'TEXTURE', },
			{  2, 0,  442, 1, nil, nil,  nil, { 19236,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1636, 3, nil, nil,  nil, { 27811, 27815, 27816,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  361, 3, nil, nil,  nil, { 14892, 15362, 15363,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1635, 2, nil, nil,  nil, { 27789, 27790,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  408, 3, nil, nil,  nil, { 14912, 15013, 15014,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  403, 2,   1,   2, 1181, { 14909, 15017,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  413, 2, nil, nil,  nil, { 14911, 15018,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1561, 1, nil, nil,  nil, { 20711,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  402, 5, nil, nil,  nil, { 14901, 15028, 15029, 15030, 15031, }, 'TEXTURE', },
			{  5, 0, 1766, 2, nil, nil,  nil, { 33150, 33154,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  404, 5, nil, nil,  nil, { 14898, 15349, 15354, 15355, 15356, }, 'TEXTURE', },
			{  6, 0, 1768, 3, nil, nil,  nil, { 34753, 34859, 34860,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1637, 1,   4,   1, 1561, {   724,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1765, 3, nil, nil,  nil, { 33142, 33145, 33146,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2279, 2, nil, nil,  nil, { 64127, 64129,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1767, 5, nil, nil,  nil, { 33158, 33159, 33160, 33161, 33162, }, 'TEXTURE', },
			{  7, 2, 1904, 3, nil, nil,  nil, { 63730, 63733, 63737,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1902, 3, nil, nil,  nil, { 63534, 63542, 63543,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1815, 1, nil, nil,  nil, { 34861,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1903, 3, nil, nil,  nil, { 47558, 47559, 47560,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1905, 5, nil, nil,  nil, { 47562, 47564, 47565, 47566, 47567, }, 'TEXTURE', },
			{ 10, 1, 1911, 1, nil, nil,  nil, { 47788,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[201] = {
			{  0, 1,  342, 5, nil, nil,  nil, { 14522, 14788, 14789, 14790, 14791, }, 'TEXTURE', },
			{  0, 2, 1898, 5, nil, nil,  nil, { 47586, 47587, 47588, 52802, 52803, }, 'TEXTURE', },
			{  1, 0,  352, 3, nil, nil,  nil, { 14523, 14784, 14785,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  346, 3, nil, nil,  nil, { 14747, 14770, 14771,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  344, 2, nil, nil,  nil, { 14749, 14767,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,  321, 2, nil, nil,  nil, { 14531, 14774,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  347, 3, nil, nil,  nil, { 14521, 14776, 14777,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  348, 1, nil, nil,  nil, { 14751,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  343, 3, nil, nil,  nil, { 14748, 14768, 14769,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1769, 3, nil, nil,  nil, { 33167, 33171, 33172,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  341, 3, nil, nil,  nil, { 14520, 14780, 14781,   nil,   nil, }, 'TEXTURE', },
			{  3, 3,  350, 2, nil, nil,  nil, { 14750, 14772,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2268, 2, nil, nil,  nil, { 33201, 33202,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 1201, 5, nil, nil,  nil, { 18551, 18552, 18553, 18554, 18555, }, 'TEXTURE', },
			{  4, 2,  351, 1,   2,   2,  343, { 63574,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1771, 2, nil, nil,  nil, { 33186, 33190,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1772, 3, nil, nil,  nil, { 34908, 34909, 34910,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1858, 3, nil, nil,  nil, { 45234, 45243, 45244,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  322, 1,   4,   1, 1201, { 10060,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1773, 3, nil, nil,  nil, { 63504, 63505, 63506,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2235, 2, nil, nil,  nil, { 57470, 57472,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1896, 3, nil, nil,  nil, { 47535, 47536, 47537,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1894, 2, nil, nil,  nil, { 47507, 47508,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1895, 3, nil, nil,  nil, { 47509, 47511, 47515,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1774, 1, nil, nil,  nil, { 33206,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1901, 2, nil, nil,  nil, { 47516, 47517,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1202, 5, nil, nil,  nil, { 52795, 52797, 52798, 52799, 52800, }, 'TEXTURE', },
			{ 10, 1, 1897, 1, nil, nil,  nil, { 47540,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	ROGUE = {
		[182] = {
			{  0, 0,  276, 3, nil, nil,  nil, { 14162, 14163, 14164,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  272, 2, nil, nil,  nil, { 14144, 14148,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  270, 5, nil, nil,  nil, { 14138, 14139, 14140, 14141, 14142, }, 'TEXTURE', },
			{  1, 0,  273, 3, nil, nil,  nil, { 14156, 14160, 14161,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 2068, 2, nil, nil,  nil, { 51632, 51633,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,  277, 3, nil, nil,  nil, { 13733, 13865, 13866,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  382, 1, nil, nil,  nil, { 14983,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  278, 2, nil, nil,  nil, { 14168, 14169,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  269, 5,   0,   2,  270, { 14128, 14132, 14135, 14136, 14137, }, 'TEXTURE', },
			{  3, 1,  682, 3, nil, nil,  nil, { 16513, 16514, 16515,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  268, 5, nil, nil,  nil, { 14113, 14114, 14115, 14116, 14117, }, 'TEXTURE', },
			{  4, 0, 1721, 2, nil, nil,  nil, { 31208, 31209,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  280, 1, nil, nil,  nil, { 14177,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  279, 3, nil, nil,  nil, { 14174, 14175, 14176,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1762, 2, nil, nil,  nil, { 31244, 31245,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1,  283, 5,   4,   1,  280, { 14186, 14190, 14193, 14194, 14195, }, 'TEXTURE', },
			{  5, 2,  274, 2, nil, nil,  nil, { 14158, 14159,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 2065, 2, nil, nil,  nil, { 51625, 51626,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  281, 1, nil, nil,  nil, { 58426,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1723, 3, nil, nil,  nil, { 31380, 31382, 31383,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2069, 3, nil, nil,  nil, { 51634, 51635, 51636,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1718, 3, nil, nil,  nil, { 31234, 31235, 31236,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1715, 3, nil, nil,  nil, { 31226, 31227, 58410,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1719, 1,   6,   1,  281, {  1329,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2066, 3, nil, nil,  nil, { 51627, 51628, 51629,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2070, 5, nil, nil,  nil, { 51664, 51665, 51667, 51668, 51669, }, 'TEXTURE', },
			{ 10, 1, 2071, 1, nil, nil,  nil, { 51662,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[181] = {
			{  0, 0,  203, 3, nil, nil,  nil, { 13741, 13793, 13792,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  201, 2, nil, nil,  nil, { 13732, 13863,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  221, 5, nil, nil,  nil, { 13715, 13848, 13849, 13851, 13852, }, 'TEXTURE', },
			{  1, 0, 1827, 2, nil, nil,  nil, { 14165, 14166,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  187, 3, nil, nil,  nil, { 13713, 13853, 13854,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,  181, 5, nil, nil,  nil, { 13705, 13832, 13843, 13844, 13845, }, 'TEXTURE', },
			{  2, 0,  204, 2, nil, nil,  nil, { 13742, 13872,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  301, 1,   1,   1,  187, { 14251,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  182, 5,   0,   2,  221, { 13706, 13804, 13805, 13806, 13807, }, 'TEXTURE', },
			{  3, 0,  206, 2, nil, nil,  nil, { 13754, 13867,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  222, 2, nil, nil,  nil, { 13743, 13875,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  186, 3, nil, nil,  nil, { 13712, 13788, 13789,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1122, 5, nil, nil,  nil, { 18427, 18428, 18429, 61330, 61331, }, 'TEXTURE', },
			{  4, 0,  184, 5, nil, nil,  nil, { 13709, 13800, 13801, 13802, 13803, }, 'TEXTURE', },
			{  4, 1,  223, 1, nil, nil,  nil, { 13877,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  242, 5, nil, nil,  nil, { 13960, 13961, 13962, 13963, 13964, }, 'TEXTURE', },
			{  5, 1, 1703, 2,   4,   1,  223, { 30919, 30920,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1706, 2, nil, nil,  nil, { 31124, 31126,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1705, 3, nil, nil,  nil, { 31122, 31123, 61329,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  205, 1, nil, nil,  nil, { 13750,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1707, 2, nil, nil,  nil, { 31130, 31131,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2072, 2, nil, nil,  nil, {  5952, 51679,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1825, 5, nil, nil,  nil, { 35541, 35550, 35551, 35552, 35553, }, 'TEXTURE', },
			{  8, 0, 2073, 2, nil, nil,  nil, { 51672, 51674,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1709, 1,   6,   1,  205, { 32601,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2074, 2, nil, nil,  nil, { 51682, 58413,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2075, 5, nil, nil,  nil, { 51685, 51686, 51687, 51688, 51689, }, 'TEXTURE', },
			{ 10, 1, 2076, 1, nil, nil,  nil, { 51690,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[183] = {
			{  0, 0, 2244, 5, nil, nil,  nil, { 14179, 58422, 58423, 58424, 58425, }, 'TEXTURE', },
			{  0, 1,  241, 3, nil, nil,  nil, { 13958, 13970, 13971,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  261, 2, nil, nil,  nil, { 14057, 14072,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 1700, 2, nil, nil,  nil, { 30892, 30893,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  262, 2, nil, nil,  nil, { 14076, 14094,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  244, 3, nil, nil,  nil, { 13975, 14062, 14063,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  247, 2, nil, nil,  nil, { 13981, 14066,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  303, 1, nil, nil,  nil, { 14278,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1123, 3, nil, nil,  nil, { 14171, 14172, 14173,   nil,   nil, }, 'TEXTURE', },
			{  3, 0,  246, 3, nil, nil,  nil, { 13983, 14070, 14071,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  245, 3, nil, nil,  nil, { 13976, 13979, 13980,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  263, 2, nil, nil,  nil, { 14079, 14080,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1701, 2, nil, nil,  nil, { 30894, 30895,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  284, 1, nil, nil,  nil, { 14185,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  265, 2, nil, nil,  nil, { 14082, 14083,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3,  681, 1,   2,   2, 1123, { 16511,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1713, 3, nil, nil,  nil, { 31221, 31222, 31223,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1702, 5, nil, nil,  nil, { 30902, 30903, 30904, 30905, 30906, }, 'TEXTURE', },
			{  6, 0, 1711, 3, nil, nil,  nil, { 31211, 31212, 31213,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  381, 1,   4,   1,  284, { 14183,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1722, 3, nil, nil,  nil, { 31228, 31229, 31230,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1712, 5,   6,   1,  381, { 31216, 31217, 31218, 31219, 31220, }, 'TEXTURE', },
			{  7, 2, 2077, 2, nil, nil,  nil, { 51692, 51696,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2078, 3, nil, nil,  nil, { 51698, 51700, 51701,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1714, 1, nil, nil,  nil, { 36554,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2079, 2, nil, nil,  nil, { 58414, 58415,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2080, 5, nil, nil,  nil, { 51708, 51709, 51710, 51711, 51712, }, 'TEXTURE', },
			{ 10, 1, 2081, 1, nil, nil,  nil, { 51713,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	SHAMAN = {
		[262] = {
			{  0, 1,  586, 5, nil, nil,  nil, { 16182, 16226, 16227, 16228, 16229, }, 'TEXTURE', },
			{  0, 2,  595, 5, nil, nil,  nil, { 16173, 16222, 16223, 16224, 16225, }, 'TEXTURE', },
			{  1, 0,  589, 2, nil, nil,  nil, { 16184, 16209,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1646, 3, nil, nil,  nil, { 29187, 29189, 29191,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  593, 5, nil, nil,  nil, { 16179, 16214, 16215, 16216, 16217, }, 'TEXTURE', },
			{  2, 0,  583, 3, nil, nil,  nil, { 16180, 16196, 16198,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  587, 3, nil, nil,  nil, { 16181, 16230, 16232,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  582, 1, nil, nil,  nil, { 55198,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  581, 3, nil, nil,  nil, { 16176, 16235, 16240,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  588, 3, nil, nil,  nil, { 16187, 16205, 16206,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  594, 5, nil, nil,  nil, { 16194, 16218, 16219, 16220, 16221, }, 'TEXTURE', },
			{  4, 0, 1648, 3, nil, nil,  nil, { 29206, 29205, 29202,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  591, 1, nil, nil,  nil, { 16188,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1695, 3, nil, nil,  nil, { 30864, 30865, 30866,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  592, 5, nil, nil,  nil, { 16178, 16210, 16211, 16212, 16213, }, 'TEXTURE', },
			{  6, 0, 1699, 5, nil, nil,  nil, { 30881, 30883, 30884, 30885, 30886, }, 'TEXTURE', },
			{  6, 1,  590, 1,   3,   1,  588, { 16190,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 2084, 1,   5,   2,  592, { 51886,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2060, 2, nil, nil,  nil, { 51554, 51555,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1697, 2, nil, nil,  nil, { 30872, 30873,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1696, 3, nil, nil,  nil, { 30867, 30868, 30869,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2061, 3, nil, nil,  nil, { 51556, 51557, 51558,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1698, 1, nil, nil,  nil, {   974,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2059, 2,   8,   1, 1698, { 51560, 51561,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2063, 5, nil, nil,  nil, { 51562, 51563, 51564, 51565, 51566, }, 'TEXTURE', },
			{ 10, 1, 2064, 1, nil, nil,  nil, { 61295,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[263] = {
			{  0, 0,  610, 3, nil, nil,  nil, { 16259, 16295, 52456,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2101, 2, nil, nil,  nil, { 16043, 16130,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  614, 5, nil, nil,  nil, { 17485, 17486, 17487, 17488, 17489, }, 'TEXTURE', },
			{  1, 0,  609, 2, nil, nil,  nil, { 16258, 16293,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  613, 5, nil, nil,  nil, { 16255, 16302, 16303, 16304, 16305, }, 'TEXTURE', },
			{  1, 2,  605, 2, nil, nil,  nil, { 16262, 16287,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3,  607, 3, nil, nil,  nil, { 16261, 16290, 51881,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  611, 3, nil, nil,  nil, { 16266, 29079, 29080,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  617, 1, nil, nil,  nil, { 43338,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  601, 3, nil, nil,  nil, { 16254, 16271, 16272,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  602, 5,   1,   1,  613, { 16256, 16281, 16282, 16283, 16284, }, 'TEXTURE', },
			{  3, 2,  615, 5, nil, nil,  nil, { 16252, 16306, 16307, 16308, 16309, }, 'TEXTURE', },
			{  4, 0, 1647, 2, nil, nil,  nil, { 29192, 29193,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  616, 1, nil, nil,  nil, { 16268,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2083, 3, nil, nil,  nil, { 51883, 51884, 51885,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1689, 3, nil, nil,  nil, { 30802, 30808, 30809,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 1643, 3, nil, nil,  nil, { 29082, 29084, 29086,   nil,   nil, }, 'TEXTURE', },
			{  5, 3, 2263, 2, nil, nil,  nil, { 63373, 63374,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1692, 3,   6,   1, 1690, { 30816, 30818, 30819,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1690, 1,   4,   1,  616, { 30798,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2,  901, 1, nil, nil,  nil, { 17364,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2055, 3, nil, nil,  nil, { 51525, 51526, 51527,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 2249, 1,   6,   1, 1690, { 60103,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 2054, 2,   6,   2,  901, { 51521, 51522,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1691, 3, nil, nil,  nil, { 30812, 30813, 30814,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1693, 1, nil, nil,  nil, { 30823,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2056, 2, nil, nil,  nil, { 51523, 51524,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2057, 5, nil, nil,  nil, { 51528, 51529, 51530, 51531, 51532, }, 'TEXTURE', },
			{ 10, 1, 2058, 1, nil, nil,  nil, { 51533,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[261] = {
			{  0, 1,  564, 5, nil, nil,  nil, { 16039, 16109, 16110, 16111, 16112, }, 'TEXTURE', },
			{  0, 2,  563, 5, nil, nil,  nil, { 16035, 16105, 16106, 16107, 16108, }, 'TEXTURE', },
			{  1, 0,  561, 3, nil, nil,  nil, { 16038, 16160, 16161,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1640, 3, nil, nil,  nil, { 28996, 28997, 28998,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1645, 3, nil, nil,  nil, { 30160, 29179, 29180,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  575, 5, nil, nil,  nil, { 16040, 16113, 16114, 16115, 16116, }, 'TEXTURE', },
			{  2, 1,  574, 1, nil, nil,  nil, { 16164,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  565, 5, nil, nil,  nil, { 16089, 60184, 60185, 60187, 60188, }, 'TEXTURE', },
			{  3, 0,  567, 2, nil, nil,  nil, { 16086, 16544,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1642, 3, nil, nil,  nil, { 29062, 29064, 29065,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1641, 2, nil, nil,  nil, { 28999, 29000,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  562, 1,   2,   1,  574, { 16041,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 1682, 3, nil, nil,  nil, { 30664, 30665, 30666,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1685, 3, nil, nil,  nil, { 30672, 30673, 30674,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  721, 5,   2,   2,  565, { 16578, 16579, 16580, 16581, 16582, }, 'TEXTURE', },
			{  6, 1,  573, 1,   4,   1,  562, { 16166,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 2052, 3, nil, nil,  nil, { 51483, 51485, 51486,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2262, 2, nil, nil,  nil, { 63370, 63372,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 2049, 2,   6,   1,  573, { 51466, 51470,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1686, 3, nil, nil,  nil, { 30675, 30678, 30679,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2050, 3, nil, nil,  nil, { 51474, 51478, 51479,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1687, 1, nil, nil,  nil, { 30706,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2051, 3, nil, nil,  nil, { 51480, 51481, 51482,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2252, 5, nil, nil,  nil, { 62097, 62098, 62099, 62100, 62101, }, 'TEXTURE', },
			{ 10, 1, 2053, 1, nil, nil,  nil, { 51490,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	WARLOCK = {
		[301] = {
			{  0, 1,  944, 5, nil, nil,  nil, { 17793, 17796, 17801, 17802, 17803, }, 'TEXTURE', },
			{  0, 2,  943, 5, nil, nil,  nil, { 17788, 17789, 17790, 17791, 17792, }, 'TEXTURE', },
			{  1, 0,  982, 2, nil, nil,  nil, { 18119, 18120,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1887, 3, nil, nil,  nil, { 63349, 63350, 63351,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  941, 3, nil, nil,  nil, { 17778, 17779, 17780,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  983, 2, nil, nil,  nil, { 18126, 18127,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  963, 1, nil, nil,  nil, { 17877,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  967, 5, nil, nil,  nil, { 17959, 59738, 59739, 59740, 59741, }, 'TEXTURE', },
			{  3, 0,  985, 2, nil, nil,  nil, { 18135, 18136,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  964, 2, nil, nil,  nil, { 17917, 17918,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3,  965, 3, nil, nil,  nil, { 17927, 17929, 17930,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1817, 3,   3,   0,  985, { 34935, 34938, 34939,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  961, 3, nil, nil,  nil, { 17815, 17833, 17834,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  981, 1,   2,   2,  967, { 18130,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1679, 3, nil, nil,  nil, { 30299, 30301, 30302,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  966, 5, nil, nil,  nil, { 17954, 17955, 17956, 17957, 17958, }, 'TEXTURE', },
			{  6, 1,  968, 1,   4,   1,  961, { 17962,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1678, 3, nil, nil,  nil, { 30293, 30295, 30296,   nil,   nil, }, 'TEXTURE', },
			{  6, 3,  986, 3, nil, nil,  nil, { 18096, 18073, 63245,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1677, 5, nil, nil,  nil, { 30288, 30289, 30290, 30291, 30292, }, 'TEXTURE', },
			{  7, 2, 1889, 2,   6,   2, 1678, { 54117, 54118,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1888, 3,   6,   1,  968, { 47258, 47259, 47260,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1676, 1, nil, nil,  nil, { 30283,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2045, 3, nil, nil,  nil, { 47220, 47221, 47223,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1890, 5, nil, nil,  nil, { 47266, 47267, 47268, 47269, 47270, }, 'TEXTURE', },
			{ 10, 1, 1891, 1, nil, nil,  nil, { 50796,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[302] = {
			{  0, 0, 1284, 2, nil, nil,  nil, { 18827, 18829,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1005, 3, nil, nil,  nil, { 18174, 18175, 18176,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 1003, 5, nil, nil,  nil, { 17810, 17811, 17812, 17813, 17814, }, 'TEXTURE', },
			{  1, 0, 1006, 2, nil, nil,  nil, { 18179, 18180,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1101, 2, nil, nil,  nil, { 18213, 18372,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1007, 2, nil, nil,  nil, { 18182, 18183,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 1004, 2, nil, nil,  nil, { 17804, 17805,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2205, 2, nil, nil,  nil, { 53754, 53759,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1001, 3, nil, nil,  nil, { 17783, 17784, 17785,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1061, 1, nil, nil,  nil, { 18288,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 0, 1021, 2, nil, nil,  nil, { 18218, 18219,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 1002, 2, nil, nil,  nil, { 18094, 18095,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 1764, 3, nil, nil,  nil, { 32381, 32382, 32383,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1763, 5, nil, nil,  nil, { 32385, 32387, 32392, 32393, 32394, }, 'TEXTURE', },
			{  4, 1, 1041, 1, nil, nil,  nil, { 63108,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1081, 1,   2,   2, 1061, { 18223,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1873, 2, nil, nil,  nil, { 54037, 54038,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 1042, 5,   4,   1, 1041, { 18271, 18272, 18273, 18274, 18275, }, 'TEXTURE', },
			{  6, 0, 1878, 3, nil, nil,  nil, { 47195, 47196, 47197,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1669, 5, nil, nil,  nil, { 30060, 30061, 30062, 30063, 30064, }, 'TEXTURE', },
			{  6, 2, 1022, 1, nil, nil,  nil, { 18220,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1668, 2, nil, nil,  nil, { 30054, 30057,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1667, 3, nil, nil,  nil, { 32477, 32483, 32484,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1875, 3, nil, nil,  nil, { 47198, 47199, 47200,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1670, 1,   6,   1, 1669, { 30108,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 2245, 1,   8,   1, 1670, { 58435,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1876, 5, nil, nil,  nil, { 47201, 47202, 47203, 47204, 47205, }, 'TEXTURE', },
			{ 10, 1, 2041, 1, nil, nil,  nil, { 48181,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[303] = {
			{  0, 0, 1221, 2, nil, nil,  nil, { 18692, 18693,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1222, 3, nil, nil,  nil, { 18694, 18695, 18696,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 1223, 3, nil, nil,  nil, { 18697, 18698, 18699,   nil,   nil, }, 'TEXTURE', },
			{  0, 3, 1883, 2, nil, nil,  nil, { 47230, 47231,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 1224, 2, nil, nil,  nil, { 18703, 18704,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 1225, 3, nil, nil,  nil, { 18705, 18706, 18707,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 1242, 3, nil, nil,  nil, { 18731, 18743, 18744,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 1243, 3, nil, nil,  nil, { 18754, 18755, 18756,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 1282, 1, nil, nil,  nil, { 19028,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1226, 1, nil, nil,  nil, { 18708,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 1671, 3, nil, nil,  nil, { 30143, 30144, 30145,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 1262, 5,   2,   1, 1282, { 18769, 18770, 18771, 18772, 18773, }, 'TEXTURE', },
			{  3, 2, 1227, 2,   2,   2, 1226, { 18709, 18710,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 1281, 1,   3,   1, 1262, { 30326,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1261, 2, nil, nil,  nil, { 18767, 18768,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 1244, 5,   3,   1, 1262, { 23785, 23822, 23823, 23824, 23825, }, 'TEXTURE', },
			{  5, 2, 1283, 3, nil, nil,  nil, { 47245, 47246, 47247,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1680, 3, nil, nil,  nil, { 30319, 30320, 30321,   nil,   nil, }, 'TEXTURE', },
			{  6, 1, 1880, 1,   5,   1, 1244, { 47193,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1263, 3, nil, nil,  nil, { 35691, 35692, 35693,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1673, 5, nil, nil,  nil, { 30242, 30245, 30246, 30247, 30248, }, 'TEXTURE', },
			{  7, 2, 2261, 2, nil, nil,  nil, { 63156, 63158,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1882, 3,   7,   1, 1673, { 54347, 54348, 54349,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1672, 1, nil, nil,  nil, { 30146,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1884, 3, nil, nil,  nil, { 63117, 63121, 63123,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1885, 5, nil, nil,  nil, { 47236, 47237, 47238, 47239, 47240, }, 'TEXTURE', },
			{ 10, 1, 1886, 1, nil, nil,  nil, { 59672,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	WARRIOR = {
		[161] = {
			{  0, 0,  124, 3, nil, nil,  nil, { 12282, 12663, 12664,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  130, 5, nil, nil,  nil, { 16462, 16463, 16464, 16465, 16466, }, 'TEXTURE', },
			{  0, 2,  127, 2, nil, nil,  nil, { 12286, 12658,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0,  126, 2, nil, nil,  nil, { 12285, 12697,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  641, 3, nil, nil,  nil, { 12300, 12959, 12960,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  128, 3, nil, nil,  nil, { 12295, 12676, 12677,   nil,   nil, }, 'TEXTURE', },
			{  2, 0,  131, 2, nil, nil,  nil, { 12290, 12963,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  137, 1, nil, nil,  nil, { 12296,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  662, 2, nil, nil,  nil, { 16493, 16494,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  121, 3,   2,   2,  662, { 12834, 12849, 12867,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  136, 3, nil, nil,  nil, { 12163, 12711, 12712,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2232, 3, nil, nil,  nil, { 56636, 56637, 56638,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  132, 5, nil, nil,  nil, { 12700, 12781, 12783, 12784, 12785, }, 'TEXTURE', },
			{  4, 1,  133, 1, nil, nil,  nil, { 12328,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  125, 5, nil, nil,  nil, { 12284, 12701, 12702, 12703, 12704, }, 'TEXTURE', },
			{  4, 3,  123, 5, nil, nil,  nil, { 12281, 12812, 12813, 12814, 12815, }, 'TEXTURE', },
			{  5, 0,  134, 2, nil, nil,  nil, { 20504, 20505,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  129, 3, nil, nil,  nil, { 12289, 12668, 23695,   nil,   nil, }, 'TEXTURE', },
			{  5, 3, 1859, 2, nil, nil,  nil, { 46854, 46855,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 0, 1663, 2, nil, nil,  nil, { 29834, 29838,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  135, 1,   4,   1,  133, { 12294,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1862, 2, nil, nil,  nil, { 46865, 46866,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 3, 2233, 2, nil, nil,  nil, { 12862, 12330,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 2283, 1, nil, nil,  nil, { 64976,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1824, 3,   6,   1,  135, { 35446, 35448, 35449,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1860, 2, nil, nil,  nil, { 46859, 46860,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 1662, 3, nil, nil,  nil, { 29723, 29725, 29724,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1661, 1, nil, nil,  nil, { 29623,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1664, 2, nil, nil,  nil, { 29836, 29859,   nil,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2231, 5, nil, nil,  nil, { 46867, 56611, 56612, 56613, 56614, }, 'TEXTURE', },
			{ 10, 1, 1863, 1, nil, nil,  nil, { 46924,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[163] = {
			{  0, 0,  142, 2, nil, nil,  nil, { 12301, 12818,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 1601, 5, nil, nil,  nil, { 12298, 12724, 12725, 12726, 12727, }, 'TEXTURE', },
			{  0, 2,  141, 3, nil, nil,  nil, { 12287, 12665, 12666,   nil,   nil, }, 'TEXTURE', },
			{  1, 1,  144, 3, nil, nil,  nil, { 50685, 50686, 50687,   nil,   nil, }, 'TEXTURE', },
			{  1, 2,  138, 5, nil, nil,  nil, { 12297, 12750, 12751, 12752, 12753, }, 'TEXTURE', },
			{  2, 0,  153, 1, nil, nil,  nil, { 12975,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  147, 2, nil, nil,  nil, { 12797, 12799,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 1654, 2, nil, nil,  nil, { 29598, 29599,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  140, 5, nil, nil,  nil, { 12299, 12761, 12762, 12763, 12764, }, 'TEXTURE', },
			{  3, 0, 2247, 2, nil, nil,  nil, { 59088, 59089,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1,  151, 2, nil, nil,  nil, { 12313, 12804,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  146, 3, nil, nil,  nil, { 12308, 12810, 12811,   nil,   nil, }, 'TEXTURE', },
			{  4, 0,  150, 2, nil, nil,  nil, { 12312, 12803,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  152, 1, nil, nil,  nil, { 12809,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2,  149, 2, nil, nil,  nil, { 12311, 12958,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  702, 5, nil, nil,  nil, { 16538, 16539, 16540, 16541, 16542, }, 'TEXTURE', },
			{  6, 0, 1652, 2, nil, nil,  nil, { 29593, 29594,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  148, 1,   4,   1,  152, { 50720,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 2, 1660, 3, nil, nil,  nil, { 29787, 29790, 29792,   nil,   nil, }, 'TEXTURE', },
			{  7, 1, 1653, 3, nil, nil,  nil, { 29140, 29143, 29144,   nil,   nil, }, 'TEXTURE', },
			{  7, 2, 1870, 2, nil, nil,  nil, { 46945, 46949,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 0, 2236, 1, nil, nil,  nil, { 57499,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1666, 1, nil, nil,  nil, { 20243,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1893, 3, nil, nil,  nil, { 47294, 47295, 47296,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 1871, 3,   8,   1, 1666, { 46951, 46952, 46953,   nil,   nil, }, 'TEXTURE', },
			{  9, 2, 2246, 2, nil, nil,  nil, { 58872, 58874,   nil,   nil,   nil, }, 'TEXTURE', },
			{ 10, 1, 1872, 1, nil, nil,  nil, { 46968,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[164] = {
			{  0, 0, 2250, 3, nil, nil,  nil, { 61216, 61221, 61222,   nil,   nil, }, 'TEXTURE', },
			{  0, 1,  158, 2, nil, nil,  nil, { 12321, 12835,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2,  157, 5, nil, nil,  nil, { 12320, 12852, 12853, 12855, 12856, }, 'TEXTURE', },
			{  1, 1,  161, 5, nil, nil,  nil, { 12324, 12876, 12877, 12878, 12879, }, 'TEXTURE', },
			{  1, 2,  159, 5, nil, nil,  nil, { 12322, 12999, 13000, 13001, 13002, }, 'TEXTURE', },
			{  2, 0,  166, 3, nil, nil,  nil, { 12329, 12950, 20496,   nil,   nil, }, 'TEXTURE', },
			{  2, 1,  160, 1, nil, nil,  nil, { 12323,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2,  661, 3, nil, nil,  nil, { 16487, 16489, 16492,   nil,   nil, }, 'TEXTURE', },
			{  2, 3,  154, 5, nil, nil,  nil, { 12318, 12857, 12858, 12860, 12861, }, 'TEXTURE', },
			{  3, 0, 1581, 5, nil, nil,  nil, { 23584, 23585, 23586, 23587, 23588, }, 'TEXTURE', },
			{  3, 1, 1542, 2, nil, nil,  nil, { 20502, 20503,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2,  155, 5, nil, nil,  nil, { 12317, 13045, 13046, 13047, 13048, }, 'TEXTURE', },
			{  4, 0, 1657, 3, nil, nil,  nil, { 29590, 29591, 29592,   nil,   nil, }, 'TEXTURE', },
			{  4, 1,  165, 1, nil, nil,  nil, { 12292,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 1543, 2, nil, nil,  nil, { 29888, 29889,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 1541, 2, nil, nil,  nil, { 20500, 20501,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2,  156, 5, nil, nil,  nil, { 12319, 12971, 12972, 12973, 12974, }, 'TEXTURE', },
			{  6, 0, 1864, 3, nil, nil,  nil, { 46908, 46909, 56924,   nil,   nil, }, 'TEXTURE', },
			{  6, 1,  167, 1,   4,   1,  165, { 23881,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  6, 3, 1655, 2, nil, nil,  nil, { 29721, 29776,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 0, 1865, 2, nil, nil,  nil, { 46910, 46911,   nil,   nil,   nil, }, 'TEXTURE', },
			{  7, 3, 1658, 5, nil, nil,  nil, { 29759, 29760, 29761, 29762, 29763, }, 'TEXTURE', },
			{  8, 0, 1868, 1, nil, nil,  nil, { 60970,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 1, 1659, 1,   6,   1,  167, { 29801,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  8, 2, 1866, 3,   6,   1,  167, { 46913, 46914, 46915,   nil,   nil, }, 'TEXTURE', },
			{  9, 1, 2234, 5, nil, nil,  nil, { 56927, 56929, 56930, 56931, 56932, }, 'TEXTURE', },
			{ 10, 1, 1867, 1, nil, nil,  nil, { 46917,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	--[[
	PET = {
		[409] = {
			{  0, 0, 2114, 2, nil, nil,  nil, { 61682, 61683,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2237, 1, nil, nil,  nil, { 61685,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 2116, 3, nil, nil,  nil, { 61686, 61687, 61688,   nil,   nil, }, 'TEXTURE', },
			{  0, 3, 2117, 2, nil, nil,  nil, { 61689, 61690,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 2126, 3, nil, nil,  nil, { 53182, 53183, 53184,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 2160, 1, nil, nil,  nil, { 19596,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 2173, 2,   0,   2, 2116, { 53481, 53482,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 2122, 2,   0,   3, 2117, { 53175, 53176,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2110, 3, nil, nil,  nil, { 61680, 61681, 52858,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 2123, 2, nil, nil,  nil, { 53178, 53179,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 2162, 2, nil, nil,  nil, { 53409, 53411,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 2277, 1, nil, nil,  nil, { 63900,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2163, 2, nil, nil,  nil, { 53450, 53451,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2161, 3, nil, nil,  nil, { 53427, 53429, 53430,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2171, 1, nil, nil,  nil, { 53478,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 2170, 1,   2,   1, 2123, { 53477,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2172, 1,   3,   2, 2163, { 53480,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 2169, 1, nil, nil,  nil, { 53476,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 1, 2258, 2, nil, nil,  nil, { 62764, 62765,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 2255, 2,   4,   2, 2172, { 62758, 62762,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[410] = {
			{  0, 0, 2107, 2, nil, nil,  nil, { 61682, 61683,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2109, 1, nil, nil,  nil, { 61684,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2203, 1, nil, nil,  nil, { 23145,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 2112, 3, nil, nil,  nil, { 61686, 61687, 61688,   nil,   nil, }, 'TEXTURE', },
			{  0, 3, 2113, 2, nil, nil,  nil, { 61689, 61690,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 2124, 2, nil, nil,  nil, { 53180, 53181,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 2128, 2, nil, nil,  nil, { 53186, 53187,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 2125, 3, nil, nil,  nil, { 53182, 53183, 53184,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 2151, 1, nil, nil,  nil, { 19596,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2106, 3, nil, nil,  nil, { 61680, 61681, 52858,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 2152, 2, nil, nil,  nil, { 53409, 53411,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 2111, 1, nil, nil,  nil, { 61685,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 3, 2219, 1, nil, nil,  nil, { 52825,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 2156, 1,   1,   1, 2128, { 55709,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2129, 3, nil, nil,  nil, { 53203, 53204, 53205,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2154, 3, nil, nil,  nil, { 53427, 53429, 53430,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2155, 1, nil, nil,  nil, { 53401,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 2153, 1,   3,   1, 2156, { 53426,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2157, 1,   3,   2, 2129, { 53434,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 2254, 2, nil, nil,  nil, { 62759, 62760,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 2, 2253, 2,   4,   2, 2157, { 62758, 62762,   nil,   nil,   nil, }, 'TEXTURE', },
		},
		[411] = {
			{  0, 0, 2118, 2, nil, nil,  nil, { 61682, 61683,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2119, 1, nil, nil,  nil, { 61684,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 1, 2201, 1, nil, nil,  nil, { 23145,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  0, 2, 2120, 3, nil, nil,  nil, { 61686, 61687, 61688,   nil,   nil, }, 'TEXTURE', },
			{  0, 3, 2121, 2, nil, nil,  nil, { 61689, 61690,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 0, 2165, 1, nil, nil,  nil, { 19596,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 2207, 2,   0,   1, 2119, { 53483, 53485,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 1, 2208, 2,   0,   1, 2201, { 53554, 53555,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 2, 2182, 2, nil, nil,  nil, { 53514, 53516,   nil,   nil,   nil, }, 'TEXTURE', },
			{  1, 3, 2127, 3, nil, nil,  nil, { 53182, 53183, 53184,   nil,   nil, }, 'TEXTURE', },
			{  2, 0, 2166, 3, nil, nil,  nil, { 61680, 61681, 52858,   nil,   nil, }, 'TEXTURE', },
			{  2, 1, 2167, 2, nil, nil,  nil, { 53409, 53411,   nil,   nil,   nil, }, 'TEXTURE', },
			{  2, 2, 2206, 1, nil, nil,  nil, { 54044,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 1, 2168, 3, nil, nil,  nil, { 53427, 53429, 53430,   nil,   nil, }, 'TEXTURE', },
			{  3, 2, 2177, 2, nil, nil,  nil, { 52234, 53497,   nil,   nil,   nil, }, 'TEXTURE', },
			{  3, 3, 2183, 2,   1,   3, 2127, { 53511, 53512,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 0, 2181, 1, nil, nil,  nil, { 53508,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 1, 2184, 1, nil, nil,  nil, { 53517,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 2, 2175, 1,   3,   2, 2177, { 53490,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
			{  4, 3, 2257, 2, nil, nil,  nil, { 53450, 53451,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 0, 2256, 2,   4,   0, 2181, { 62758, 62762,   nil,   nil,   nil, }, 'TEXTURE', },
			{  5, 3, 2278, 1,   4,   3, 2257, { 53480,   nil,   nil,   nil,   nil, }, 'TEXTURE', },
		},
	},
	--]]
};
--
	--	DT.SpellDB_P
	--1------2---3-----4------5-----6--------7-------8
	--level, id, cost, phase, name, passive, talent, class
	--	passive = true, talent = true, race = "", require = SpellID,
--
DT.SpellDB = {
};

DT.TalentSpecIcon = {
	[41] = "Interface\\Icons\\spell_fire_firebolt02",
	[61] = "Interface\\Icons\\spell_frost_frostbolt02",
	[81] = "Interface\\Icons\\inv_misc_rune_03",
	[161] = "Interface\\Icons\\ability_rogue_eviscerate",--
	[163] = "Interface\\Icons\\ability_warrior_defensivestance",
	[164] = "Interface\\Icons\\ability_warrior_innerrage",
	[181] = "Interface\\Icons\\ability_backstab",
	[182] = "Interface\\Icons\\ability_rogue_eviscerate",--
	[183] = "Interface\\Icons\\Ability_Ambush",
	[201] = "Interface\\Icons\\spell_holy_wordfortitude",
	[202] = "Interface\\Icons\\spell_holy_holybolt",
	[203] = "Interface\\Icons\\spell_shadow_shadowwordpain",
	[261] = "Interface\\Icons\\spell_nature_lightning",
	[262] = "Interface\\Icons\\Spell_Nature_HealingWaveGreater",
	[263] = "Interface\\Icons\\spell_nature_lightningshield",
	[281] = "Interface\\Icons\\ability_racial_bearform",
	[282] = "Interface\\Icons\\Spell_Nature_HealingTouch",
	[283] = "Interface\\Icons\\spell_nature_starfall",
	[301] = "Interface\\Icons\\spell_shadow_rainoffire",
	[302] = "Interface\\Icons\\spell_shadow_deathcoil",
	[303] = "Interface\\Icons\\spell_shadow_metamorphosis",
	[361] = "Interface\\Icons\\Ability_Hunter_BeastTaming",
	[362] = "Interface\\Icons\\Ability_Hunter_SwiftStrike",
	[363] = "Interface\\Icons\\Ability_Marksmanship",
	[381] = "Interface\\Icons\\Spell_Holy_AuraOfLight",
	[382] = "Interface\\Icons\\Spell_Holy_HolyBolt",
	[383] = "Interface\\Icons\\Spell_Holy_DevotionAura",
	
	[398] = "Interface\\Icons\\Spell_Deathknight_BloodPresence",
	[399] = "Interface\\Icons\\Spell_Deathknight_FrostPresence",
	[400] = "Interface\\Icons\\Spell_Deathknight_UnholyPresence",
	[409] = "Interface\\Icons\\Ability_Hunter_Pet_Bear",
	[410] = "Interface\\Icons\\Ability_Druid_Swipe",
	[411] = "Interface\\Icons\\Ability_Hunter_CombatExperience",
};

DT.ClassBG = {
	DEATHKNIGHT = {
		"Interface\\TalentFrame\\bg-deathknight-blood",
		"Interface\\TalentFrame\\bg-deathknight-frost",
		"Interface\\TalentFrame\\bg-deathknight-unholy",
	},
	DRUID = {
		"Interface\\TalentFrame\\bg-druid-balance",
		"Interface\\TalentFrame\\bg-druid-bear",
		"Interface\\TalentFrame\\bg-druid-cat",
		"Interface\\TalentFrame\\bg-druid-restoration",
	},
	HUNTER = {
		"Interface\\TalentFrame\\bg-hunter-beastmaster",
		"Interface\\TalentFrame\\bg-hunter-marksman",
		"Interface\\TalentFrame\\bg-hunter-survival",
	},
	MAGE = {
		"Interface\\TalentFrame\\bg-mage-arcane",
		"Interface\\TalentFrame\\bg-mage-fire",
		"Interface\\TalentFrame\\bg-mage-frost",
	},
	MONK = {
		"Interface\\TalentFrame\\bg-monk-battledancer",
		"Interface\\TalentFrame\\bg-monk-brewmaster",
		"Interface\\TalentFrame\\bg-monk-mistweaver",
	},
	PALADIN = {
		"Interface\\TalentFrame\\bg-paladin-holy",
		"Interface\\TalentFrame\\bg-paladin-protection",
		"Interface\\TalentFrame\\bg-paladin-retribution",
	},
	PRIEST = {
		"Interface\\TalentFrame\\bg-priest-discipline",
		"Interface\\TalentFrame\\bg-priest-holy",
		"Interface\\TalentFrame\\bg-priest-shadow",
	},
	ROGUE = {
		"Interface\\TalentFrame\\bg-rogue-assassination",
		"Interface\\TalentFrame\\bg-rogue-combat",
		"Interface\\TalentFrame\\bg-rogue-subtlety",
	},
	SHAMAN = {
		"Interface\\TalentFrame\\bg-shaman-elemental",
		"Interface\\TalentFrame\\bg-shaman-enhancement",
		"Interface\\TalentFrame\\bg-shaman-restoration",
	},
	WARLOCK = {
		"Interface\\TalentFrame\\bg-warlock-affliction",
		"Interface\\TalentFrame\\bg-warlock-demonology",
		"Interface\\TalentFrame\\bg-warlock-destruction",
	},
	WARRIOR = {
		"Interface\\TalentFrame\\bg-warrior-arms",
		"Interface\\TalentFrame\\bg-warrior-fury",
		"Interface\\TalentFrame\\bg-warrior-protection",
	},
};

DT.SpecBG = {
		[283] = "Interface\\TalentFrame\\DruidBalance-TopLeft",
		[281] = "Interface\\TalentFrame\\DruidFeralCombat-TopLeft",
		[282] = "Interface\\TalentFrame\\DruidRestoration-TopLeft",
		[361] = "Interface\\TalentFrame\\HunterBeastMastery-TopLeft",
		[363] = "Interface\\TalentFrame\\HunterMarksmanship-TopLeft",
		[362] = "Interface\\TalentFrame\\HunterSurvival-TopLeft",
		[81] = "Interface\\TalentFrame\\MageArcane-TopLeft",
		[41] = "Interface\\TalentFrame\\MageFire-TopLeft",
		[61] = "Interface\\TalentFrame\\MageFrost-TopLeft",
		[382] = "Interface\\TalentFrame\\PaladinHoly-TopLeft",
		[383] = "Interface\\TalentFrame\\PaladinProtection-TopLeft",
		[381] = "Interface\\TalentFrame\\PaladinCombat-TopLeft",
		[201] = "Interface\\TalentFrame\\PriestDiscipline-TopLeft",
		[202] = "Interface\\TalentFrame\\PriestHoly-TopLeft",
		[203] = "Interface\\TalentFrame\\PriestShadow-TopLeft",
		[182] = "Interface\\TalentFrame\\RogueAssassination-TopLeft",
		[181] = "Interface\\TalentFrame\\RogueCombat-TopLeft",
		[183] = "Interface\\TalentFrame\\RogueSubtlety-TopLeft",
		[261] = "Interface\\TalentFrame\\ShamanElementalCombat-TopLeft",
		[263] = "Interface\\TalentFrame\\ShamanEnhancement-TopLeft",
		[262] = "Interface\\TalentFrame\\ShamanRestoration-TopLeft",
		[302] = "Interface\\TalentFrame\\WarlockCurses-TopLeft",
		[303] = "Interface\\TalentFrame\\WarlockSummoning-TopLeft",
		[301] = "Interface\\TalentFrame\\WarlockDestruction-TopLeft",
		[161] = "Interface\\TalentFrame\\WarriorArms-TopLeft",
		[164] = "Interface\\TalentFrame\\WarriorFury-TopLeft",
		[163] = "Interface\\TalentFrame\\WarriorProtection-TopLeft",
};

DT.PresetTalents = {
};

DT.TalentMap = {
	DEATHKNIGHT = {
		RMap = {
			{
				[1] = 20,
				[2] = 4,
				[3] = 1,
				[4] = 7,
				[5] = 10,
				[6] = 8,
				[7] = 16,
				[8] = 2,
				[9] = 5,
				[10] = 15,
				[11] = 14,
				[12] = 12,
				[13] = 19,
				[14] = 22,
				[15] = 25,
				[16] = 26,
				[17] = 24,
				[18] = 18,
				[19] = 28,
				[20] = 13,
				[21] = 3,
				[22] = 11,
				[23] = 23,
				[24] = 27,
				[25] = 9,
				[26] = 17,
				[27] = 6,
				[28] = 21,
			},
			{
				[1] = 3,
				[2] = 12,
				[3] = 5,
				[4] = 26,
				[5] = 24,
				[6] = 15,
				[7] = 11,
				[8] = 29,
				[9] = 13,
				[10] = 18,
				[11] = 17,
				[12] = 25,
				[13] = 28,
				[14] = 20,
				[15] = 2,
				[16] = 6,
				[17] = 21,
				[18] = 14,
				[19] = 1,
				[20] = 4,
				[21] = 27,
				[22] = 7,
				[23] = 10,
				[24] = 9,
				[25] = 23,
				[26] = 8,
				[27] = 16,
				[28] = 19,
				[29] = 22,
			},
			{
				[1] = 2,
				[2] = 5,
				[3] = 7,
				[4] = 25,
				[5] = 4,
				[6] = 20,
				[7] = 10,
				[8] = 14,
				[9] = 31,
				[10] = 19,
				[11] = 27,
				[12] = 12,
				[13] = 15,
				[14] = 26,
				[15] = 8,
				[16] = 18,
				[17] = 16,
				[18] = 23,
				[19] = 6,
				[20] = 30,
				[21] = 11,
				[22] = 28,
				[23] = 9,
				[24] = 1,
				[25] = 24,
				[26] = 29,
				[27] = 3,
				[28] = 22,
				[29] = 13,
				[30] = 17,
				[31] = 21,
			},
		},
		VMap = {
			{
				[1] = 3,
				[2] = 8,
				[3] = 21,
				[4] = 2,
				[5] = 9,
				[6] = 27,
				[7] = 4,
				[8] = 6,
				[9] = 25,
				[10] = 5,
				[11] = 22,
				[12] = 12,
				[13] = 20,
				[14] = 11,
				[15] = 10,
				[16] = 7,
				[17] = 26,
				[18] = 18,
				[19] = 13,
				[20] = 1,
				[21] = 28,
				[22] = 14,
				[23] = 23,
				[24] = 17,
				[25] = 15,
				[26] = 16,
				[27] = 24,
				[28] = 19,
			},
			{
				[1] = 19,
				[2] = 15,
				[3] = 1,
				[4] = 20,
				[5] = 3,
				[6] = 16,
				[7] = 22,
				[8] = 26,
				[9] = 24,
				[10] = 23,
				[11] = 7,
				[12] = 2,
				[13] = 9,
				[14] = 18,
				[15] = 6,
				[16] = 27,
				[17] = 11,
				[18] = 10,
				[19] = 28,
				[20] = 14,
				[21] = 17,
				[22] = 29,
				[23] = 25,
				[24] = 5,
				[25] = 12,
				[26] = 4,
				[27] = 21,
				[28] = 13,
				[29] = 8,
			},
			{
				[1] = 24,
				[2] = 1,
				[3] = 27,
				[4] = 5,
				[5] = 2,
				[6] = 19,
				[7] = 3,
				[8] = 15,
				[9] = 23,
				[10] = 7,
				[11] = 21,
				[12] = 12,
				[13] = 29,
				[14] = 8,
				[15] = 13,
				[16] = 17,
				[17] = 30,
				[18] = 16,
				[19] = 10,
				[20] = 6,
				[21] = 31,
				[22] = 28,
				[23] = 18,
				[24] = 25,
				[25] = 4,
				[26] = 14,
				[27] = 11,
				[28] = 22,
				[29] = 26,
				[30] = 20,
				[31] = 9,
			},
		},
	},
	DRUID = {
		VMap = {
			{
				[1] = 1,
				[2] = 26,
				[3] = 5,
				[4] = 18,
				[5] = 2,
				[6] = 4,
				[7] = 8,
				[8] = 28,
				[9] = 3,
				[10] = 10,
				[11] = 6,
				[12] = 12,
				[13] = 7,
				[14] = 27,
				[15] = 14,
				[16] = 9,
				[17] = 13,
				[18] = 11,
				[19] = 19,
				[20] = 15,
				[21] = 20,
				[22] = 16,
				[23] = 22,
				[24] = 21,
				[25] = 17,
				[26] = 23,
				[27] = 25,
				[28] = 24,
			},
			{
				[1] = 3,
				[2] = 2,
				[3] = 6,
				[4] = 11,
				[5] = 1,
				[6] = 12,
				[7] = 15,
				[8] = 5,
				[9] = 8,
				[10] = 9,
				[11] = 7,
				[12] = 22,
				[13] = 4,
				[14] = 10,
				[15] = 16,
				[16] = 29,
				[17] = 13,
				[18] = 18,
				[19] = 14,
				[20] = 21,
				[21] = 17,
				[22] = 28,
				[23] = 19,
				[24] = 24,
				[25] = 26,
				[26] = 20,
				[27] = 25,
				[28] = 23,
				[29] = 30,
				[30] = 27,
			},
			{
				[1] = 1,
				[2] = 3,
				[3] = 2,
				[4] = 4,
				[5] = 12,
				[6] = 6,
				[7] = 9,
				[8] = 7,
				[9] = 21,
				[10] = 14,
				[11] = 10,
				[12] = 11,
				[13] = 8,
				[14] = 13,
				[15] = 16,
				[16] = 5,
				[17] = 20,
				[18] = 15,
				[19] = 18,
				[20] = 17,
				[21] = 24,
				[22] = 25,
				[23] = 19,
				[24] = 26,
				[25] = 27,
				[26] = 22,
				[27] = 23,
			},
		},
		RMap = {
			{
				[1] = 1,
				[2] = 5,
				[3] = 9,
				[4] = 6,
				[5] = 3,
				[6] = 11,
				[7] = 13,
				[8] = 7,
				[9] = 16,
				[10] = 10,
				[11] = 18,
				[12] = 12,
				[13] = 17,
				[14] = 15,
				[15] = 20,
				[16] = 22,
				[17] = 25,
				[18] = 4,
				[19] = 19,
				[20] = 21,
				[21] = 24,
				[22] = 23,
				[23] = 26,
				[24] = 28,
				[25] = 27,
				[26] = 2,
				[27] = 14,
				[28] = 8,
			},
			{
				[1] = 5,
				[2] = 2,
				[3] = 1,
				[4] = 13,
				[5] = 8,
				[6] = 3,
				[7] = 11,
				[8] = 9,
				[9] = 10,
				[10] = 14,
				[11] = 4,
				[12] = 6,
				[13] = 17,
				[14] = 19,
				[15] = 7,
				[16] = 15,
				[17] = 21,
				[18] = 18,
				[19] = 23,
				[20] = 26,
				[21] = 20,
				[22] = 12,
				[23] = 28,
				[24] = 24,
				[25] = 27,
				[26] = 25,
				[27] = 30,
				[28] = 22,
				[29] = 16,
				[30] = 29,
			},
			{
				[1] = 1,
				[2] = 3,
				[3] = 2,
				[4] = 4,
				[5] = 16,
				[6] = 6,
				[7] = 8,
				[8] = 13,
				[9] = 7,
				[10] = 11,
				[11] = 12,
				[12] = 5,
				[13] = 14,
				[14] = 10,
				[15] = 18,
				[16] = 15,
				[17] = 20,
				[18] = 19,
				[19] = 23,
				[20] = 17,
				[21] = 9,
				[22] = 26,
				[23] = 27,
				[24] = 21,
				[25] = 22,
				[26] = 24,
				[27] = 25,
			},
		},
	},
	WARRIOR = {
		RMap = {
			{
				[1] = 10,
				[2] = 16,
				[3] = 1,
				[4] = 15,
				[5] = 4,
				[6] = 3,
				[7] = 6,
				[8] = 18,
				[9] = 2,
				[10] = 7,
				[11] = 13,
				[12] = 14,
				[13] = 17,
				[14] = 21,
				[15] = 11,
				[16] = 8,
				[17] = 5,
				[18] = 9,
				[19] = 28,
				[20] = 27,
				[21] = 20,
				[22] = 29,
				[23] = 25,
				[24] = 19,
				[25] = 26,
				[26] = 22,
				[27] = 31,
				[28] = 30,
				[29] = 12,
				[30] = 23,
				[31] = 24,
			},
			{
				[1] = 9,
				[2] = 12,
				[3] = 17,
				[4] = 3,
				[5] = 2,
				[6] = 5,
				[7] = 7,
				[8] = 4,
				[9] = 14,
				[10] = 6,
				[11] = 19,
				[12] = 8,
				[13] = 16,
				[14] = 11,
				[15] = 15,
				[16] = 10,
				[17] = 20,
				[18] = 13,
				[19] = 22,
				[20] = 24,
				[21] = 18,
				[22] = 21,
				[23] = 25,
				[24] = 27,
				[25] = 23,
				[26] = 26,
				[27] = 1,
			},
			{
				[1] = 5,
				[2] = 9,
				[3] = 3,
				[4] = 1,
				[5] = 4,
				[6] = 12,
				[7] = 7,
				[8] = 18,
				[9] = 15,
				[10] = 13,
				[11] = 11,
				[12] = 14,
				[13] = 6,
				[14] = 16,
				[15] = 2,
				[16] = 17,
				[17] = 20,
				[18] = 8,
				[19] = 19,
				[20] = 23,
				[21] = 21,
				[22] = 25,
				[23] = 27,
				[24] = 24,
				[25] = 22,
				[26] = 26,
				[27] = 10,
			},
		},
		VMap = {
			{
				[1] = 3,
				[2] = 9,
				[3] = 6,
				[4] = 5,
				[5] = 17,
				[6] = 7,
				[7] = 10,
				[8] = 16,
				[9] = 18,
				[10] = 1,
				[11] = 15,
				[12] = 29,
				[13] = 11,
				[14] = 12,
				[15] = 4,
				[16] = 2,
				[17] = 13,
				[18] = 8,
				[19] = 24,
				[20] = 21,
				[21] = 14,
				[22] = 26,
				[23] = 30,
				[24] = 31,
				[25] = 23,
				[26] = 25,
				[27] = 20,
				[28] = 19,
				[29] = 22,
				[30] = 28,
				[31] = 27,
			},
			{
				[1] = 27,
				[2] = 5,
				[3] = 4,
				[4] = 8,
				[5] = 6,
				[6] = 10,
				[7] = 7,
				[8] = 12,
				[9] = 1,
				[10] = 16,
				[11] = 14,
				[12] = 2,
				[13] = 18,
				[14] = 9,
				[15] = 15,
				[16] = 13,
				[17] = 3,
				[18] = 21,
				[19] = 11,
				[20] = 17,
				[21] = 22,
				[22] = 19,
				[23] = 25,
				[24] = 20,
				[25] = 23,
				[26] = 26,
				[27] = 24,
			},
			{
				[1] = 4,
				[2] = 15,
				[3] = 3,
				[4] = 5,
				[5] = 1,
				[6] = 13,
				[7] = 7,
				[8] = 18,
				[9] = 2,
				[10] = 27,
				[11] = 11,
				[12] = 6,
				[13] = 10,
				[14] = 12,
				[15] = 9,
				[16] = 14,
				[17] = 16,
				[18] = 8,
				[19] = 19,
				[20] = 17,
				[21] = 21,
				[22] = 25,
				[23] = 20,
				[24] = 24,
				[25] = 22,
				[26] = 26,
				[27] = 23,
			},
		},
	},
	SHAMAN = {
		RMap = {
			{
				[1] = 3,
				[2] = 12,
				[3] = 2,
				[4] = 1,
				[5] = 8,
				[6] = 9,
				[7] = 16,
				[8] = 7,
				[9] = 6,
				[10] = 15,
				[11] = 4,
				[12] = 11,
				[13] = 10,
				[14] = 5,
				[15] = 13,
				[16] = 14,
				[17] = 20,
				[18] = 22,
				[19] = 19,
				[20] = 21,
				[21] = 23,
				[22] = 17,
				[23] = 25,
				[24] = 24,
				[25] = 18,
			},
			{
				[1] = 10,
				[2] = 11,
				[3] = 6,
				[4] = 7,
				[5] = 4,
				[6] = 1,
				[7] = 8,
				[8] = 5,
				[9] = 3,
				[10] = 12,
				[11] = 14,
				[12] = 9,
				[13] = 21,
				[14] = 17,
				[15] = 13,
				[16] = 16,
				[17] = 20,
				[18] = 25,
				[19] = 19,
				[20] = 26,
				[21] = 24,
				[22] = 22,
				[23] = 27,
				[24] = 28,
				[25] = 29,
				[26] = 15,
				[27] = 2,
				[28] = 23,
				[29] = 18,
			},
			{
				[1] = 9,
				[2] = 8,
				[3] = 6,
				[4] = 1,
				[5] = 7,
				[6] = 10,
				[7] = 3,
				[8] = 17,
				[9] = 13,
				[10] = 15,
				[11] = 5,
				[12] = 11,
				[13] = 2,
				[14] = 4,
				[15] = 12,
				[16] = 14,
				[17] = 21,
				[18] = 20,
				[19] = 23,
				[20] = 16,
				[21] = 24,
				[22] = 19,
				[23] = 22,
				[24] = 25,
				[25] = 26,
				[26] = 18,
			},
		},
		VMap = {
			{
				[1] = 4,
				[2] = 3,
				[3] = 1,
				[4] = 11,
				[5] = 14,
				[6] = 9,
				[7] = 8,
				[8] = 5,
				[9] = 6,
				[10] = 13,
				[11] = 12,
				[12] = 2,
				[13] = 15,
				[14] = 16,
				[15] = 10,
				[16] = 7,
				[17] = 22,
				[18] = 25,
				[19] = 19,
				[20] = 17,
				[21] = 20,
				[22] = 18,
				[23] = 21,
				[24] = 24,
				[25] = 23,
			},
			{
				[1] = 6,
				[2] = 27,
				[3] = 9,
				[4] = 5,
				[5] = 8,
				[6] = 3,
				[7] = 4,
				[8] = 7,
				[9] = 12,
				[10] = 1,
				[11] = 2,
				[12] = 10,
				[13] = 15,
				[14] = 11,
				[15] = 26,
				[16] = 16,
				[17] = 14,
				[18] = 29,
				[19] = 19,
				[20] = 17,
				[21] = 13,
				[22] = 22,
				[23] = 28,
				[24] = 21,
				[25] = 18,
				[26] = 20,
				[27] = 23,
				[28] = 24,
				[29] = 25,
			},
			{
				[1] = 4,
				[2] = 13,
				[3] = 7,
				[4] = 14,
				[5] = 11,
				[6] = 3,
				[7] = 5,
				[8] = 2,
				[9] = 1,
				[10] = 6,
				[11] = 12,
				[12] = 15,
				[13] = 9,
				[14] = 16,
				[15] = 10,
				[16] = 20,
				[17] = 8,
				[18] = 26,
				[19] = 22,
				[20] = 18,
				[21] = 17,
				[22] = 23,
				[23] = 19,
				[24] = 21,
				[25] = 24,
				[26] = 25,
			},
		},
	},
	MAGE = {
		RMap = {
			{
				[1] = 1,
				[2] = 6,
				[3] = 2,
				[4] = 17,
				[5] = 3,
				[6] = 8,
				[7] = 7,
				[8] = 11,
				[9] = 4,
				[10] = 16,
				[11] = 22,
				[12] = 12,
				[13] = 19,
				[14] = 13,
				[15] = 5,
				[16] = 15,
				[17] = 20,
				[18] = 18,
				[19] = 21,
				[20] = 25,
				[21] = 26,
				[22] = 29,
				[23] = 24,
				[24] = 23,
				[25] = 9,
				[26] = 28,
				[27] = 30,
				[28] = 27,
				[29] = 10,
				[30] = 14,
			},
			{
				[1] = 10,
				[2] = 12,
				[3] = 11,
				[4] = 3,
				[5] = 1,
				[6] = 7,
				[7] = 9,
				[8] = 8,
				[9] = 6,
				[10] = 16,
				[11] = 15,
				[12] = 4,
				[13] = 18,
				[14] = 20,
				[15] = 2,
				[16] = 13,
				[17] = 14,
				[18] = 17,
				[19] = 21,
				[20] = 19,
				[21] = 23,
				[22] = 25,
				[23] = 22,
				[24] = 24,
				[25] = 26,
				[26] = 27,
				[27] = 28,
				[28] = 5,
			},
			{
				[1] = 2,
				[2] = 1,
				[3] = 8,
				[4] = 3,
				[5] = 10,
				[6] = 15,
				[7] = 7,
				[8] = 12,
				[9] = 13,
				[10] = 18,
				[11] = 9,
				[12] = 5,
				[13] = 20,
				[14] = 14,
				[15] = 4,
				[16] = 11,
				[17] = 6,
				[18] = 16,
				[19] = 17,
				[20] = 21,
				[21] = 22,
				[22] = 25,
				[23] = 23,
				[24] = 24,
				[25] = 26,
				[26] = 27,
				[27] = 28,
				[28] = 19,
			},
		},
		VMap = {
			{
				[1] = 1,
				[2] = 3,
				[3] = 5,
				[4] = 9,
				[5] = 15,
				[6] = 2,
				[7] = 7,
				[8] = 6,
				[9] = 25,
				[10] = 29,
				[11] = 8,
				[12] = 12,
				[13] = 14,
				[14] = 30,
				[15] = 16,
				[16] = 10,
				[17] = 4,
				[18] = 18,
				[19] = 13,
				[20] = 17,
				[21] = 19,
				[22] = 11,
				[23] = 24,
				[24] = 23,
				[25] = 20,
				[26] = 21,
				[27] = 28,
				[28] = 26,
				[29] = 22,
				[30] = 27,
			},
			{
				[1] = 5,
				[2] = 15,
				[3] = 4,
				[4] = 12,
				[5] = 28,
				[6] = 9,
				[7] = 6,
				[8] = 8,
				[9] = 7,
				[10] = 1,
				[11] = 3,
				[12] = 2,
				[13] = 16,
				[14] = 17,
				[15] = 11,
				[16] = 10,
				[17] = 18,
				[18] = 13,
				[19] = 20,
				[20] = 14,
				[21] = 19,
				[22] = 23,
				[23] = 21,
				[24] = 24,
				[25] = 22,
				[26] = 25,
				[27] = 26,
				[28] = 27,
			},
			{
				[1] = 2,
				[2] = 1,
				[3] = 4,
				[4] = 15,
				[5] = 12,
				[6] = 17,
				[7] = 7,
				[8] = 3,
				[9] = 11,
				[10] = 5,
				[11] = 16,
				[12] = 8,
				[13] = 9,
				[14] = 14,
				[15] = 6,
				[16] = 18,
				[17] = 19,
				[18] = 10,
				[19] = 28,
				[20] = 13,
				[21] = 20,
				[22] = 21,
				[23] = 23,
				[24] = 24,
				[25] = 22,
				[26] = 25,
				[27] = 26,
				[28] = 27,
			},
		},
	},
	PRIEST = {
		RMap = {
			{
				[1] = 6,
				[2] = 19,
				[3] = 11,
				[4] = 1,
				[5] = 9,
				[6] = 5,
				[7] = 4,
				[8] = 7,
				[9] = 8,
				[10] = 12,
				[11] = 15,
				[12] = 3,
				[13] = 14,
				[14] = 27,
				[15] = 10,
				[16] = 16,
				[17] = 17,
				[18] = 20,
				[19] = 25,
				[20] = 18,
				[21] = 23,
				[22] = 24,
				[23] = 22,
				[24] = 28,
				[25] = 2,
				[26] = 26,
				[27] = 21,
				[28] = 13,
			},
			{
				[1] = 8,
				[2] = 3,
				[3] = 14,
				[4] = 11,
				[5] = 16,
				[6] = 2,
				[7] = 10,
				[8] = 1,
				[9] = 4,
				[10] = 12,
				[11] = 6,
				[12] = 5,
				[13] = 13,
				[14] = 9,
				[15] = 7,
				[16] = 18,
				[17] = 19,
				[18] = 15,
				[19] = 21,
				[20] = 17,
				[21] = 24,
				[22] = 23,
				[23] = 25,
				[24] = 22,
				[25] = 26,
				[26] = 27,
				[27] = 20,
			},
			{
				[1] = 12,
				[2] = 3,
				[3] = 6,
				[4] = 1,
				[5] = 4,
				[6] = 8,
				[7] = 5,
				[8] = 10,
				[9] = 14,
				[10] = 9,
				[11] = 19,
				[12] = 13,
				[13] = 7,
				[14] = 11,
				[15] = 15,
				[16] = 16,
				[17] = 20,
				[18] = 24,
				[19] = 17,
				[20] = 22,
				[21] = 21,
				[22] = 26,
				[23] = 23,
				[24] = 25,
				[25] = 27,
				[26] = 2,
				[27] = 18,
			},
		},
		VMap = {
			{
				[1] = 4,
				[2] = 25,
				[3] = 12,
				[4] = 7,
				[5] = 6,
				[6] = 1,
				[7] = 8,
				[8] = 9,
				[9] = 5,
				[10] = 15,
				[11] = 3,
				[12] = 10,
				[13] = 28,
				[14] = 13,
				[15] = 11,
				[16] = 16,
				[17] = 17,
				[18] = 20,
				[19] = 2,
				[20] = 18,
				[21] = 27,
				[22] = 23,
				[23] = 21,
				[24] = 22,
				[25] = 19,
				[26] = 26,
				[27] = 14,
				[28] = 24,
			},
			{
				[1] = 8,
				[2] = 6,
				[3] = 2,
				[4] = 9,
				[5] = 12,
				[6] = 11,
				[7] = 15,
				[8] = 1,
				[9] = 14,
				[10] = 7,
				[11] = 4,
				[12] = 10,
				[13] = 13,
				[14] = 3,
				[15] = 18,
				[16] = 5,
				[17] = 20,
				[18] = 16,
				[19] = 17,
				[20] = 27,
				[21] = 19,
				[22] = 24,
				[23] = 22,
				[24] = 21,
				[25] = 23,
				[26] = 25,
				[27] = 26,
			},
			{
				[1] = 4,
				[2] = 26,
				[3] = 2,
				[4] = 5,
				[5] = 7,
				[6] = 3,
				[7] = 13,
				[8] = 6,
				[9] = 10,
				[10] = 8,
				[11] = 14,
				[12] = 1,
				[13] = 12,
				[14] = 9,
				[15] = 15,
				[16] = 16,
				[17] = 19,
				[18] = 27,
				[19] = 11,
				[20] = 17,
				[21] = 21,
				[22] = 20,
				[23] = 23,
				[24] = 18,
				[25] = 24,
				[26] = 22,
				[27] = 25,
			},
		},
	},
	WARLOCK = {
		VMap = {
			{
				[1] = 15,
				[2] = 5,
				[3] = 3,
				[4] = 6,
				[5] = 14,
				[6] = 7,
				[7] = 4,
				[8] = 27,
				[9] = 1,
				[10] = 12,
				[11] = 8,
				[12] = 2,
				[13] = 21,
				[14] = 20,
				[15] = 10,
				[16] = 13,
				[17] = 22,
				[18] = 11,
				[19] = 25,
				[20] = 18,
				[21] = 9,
				[22] = 17,
				[23] = 16,
				[24] = 23,
				[25] = 19,
				[26] = 28,
				[27] = 24,
				[28] = 26,
			},
			{
				[1] = 1,
				[2] = 2,
				[3] = 3,
				[4] = 23,
				[5] = 4,
				[6] = 5,
				[7] = 8,
				[8] = 9,
				[9] = 15,
				[10] = 6,
				[11] = 17,
				[12] = 12,
				[13] = 7,
				[14] = 14,
				[15] = 11,
				[16] = 10,
				[17] = 16,
				[18] = 20,
				[19] = 21,
				[20] = 13,
				[21] = 19,
				[22] = 27,
				[23] = 22,
				[24] = 18,
				[25] = 24,
				[26] = 25,
				[27] = 26,
			},
			{
				[1] = 3,
				[2] = 2,
				[3] = 12,
				[4] = 21,
				[5] = 1,
				[6] = 13,
				[7] = 5,
				[8] = 9,
				[9] = 14,
				[10] = 6,
				[11] = 7,
				[12] = 20,
				[13] = 4,
				[14] = 11,
				[15] = 19,
				[16] = 8,
				[17] = 10,
				[18] = 18,
				[19] = 15,
				[20] = 17,
				[21] = 23,
				[22] = 22,
				[23] = 16,
				[24] = 26,
				[25] = 24,
				[26] = 25,
			},
		},
		RMap = {
			{
				[1] = 9,
				[2] = 12,
				[3] = 3,
				[4] = 7,
				[5] = 2,
				[6] = 4,
				[7] = 6,
				[8] = 11,
				[9] = 21,
				[10] = 15,
				[11] = 18,
				[12] = 10,
				[13] = 16,
				[14] = 5,
				[15] = 1,
				[16] = 23,
				[17] = 22,
				[18] = 20,
				[19] = 25,
				[20] = 14,
				[21] = 13,
				[22] = 17,
				[23] = 24,
				[24] = 27,
				[25] = 19,
				[26] = 28,
				[27] = 8,
				[28] = 26,
			},
			{
				[1] = 1,
				[2] = 2,
				[3] = 3,
				[4] = 5,
				[5] = 6,
				[6] = 10,
				[7] = 13,
				[8] = 7,
				[9] = 8,
				[10] = 16,
				[11] = 15,
				[12] = 12,
				[13] = 20,
				[14] = 14,
				[15] = 9,
				[16] = 17,
				[17] = 11,
				[18] = 24,
				[19] = 21,
				[20] = 18,
				[21] = 19,
				[22] = 23,
				[23] = 4,
				[24] = 25,
				[25] = 26,
				[26] = 27,
				[27] = 22,
			},
			{
				[1] = 5,
				[2] = 2,
				[3] = 1,
				[4] = 13,
				[5] = 7,
				[6] = 10,
				[7] = 11,
				[8] = 16,
				[9] = 8,
				[10] = 17,
				[11] = 14,
				[12] = 3,
				[13] = 6,
				[14] = 9,
				[15] = 19,
				[16] = 23,
				[17] = 20,
				[18] = 18,
				[19] = 15,
				[20] = 12,
				[21] = 4,
				[22] = 22,
				[23] = 21,
				[24] = 25,
				[25] = 26,
				[26] = 24,
			},
		},
	},
	HUNTER = {
		VMap = {
			{
				[1] = 2,
				[2] = 8,
				[3] = 14,
				[4] = 1,
				[5] = 11,
				[6] = 15,
				[7] = 3,
				[8] = 23,
				[9] = 12,
				[10] = 4,
				[11] = 10,
				[12] = 7,
				[13] = 6,
				[14] = 9,
				[15] = 16,
				[16] = 13,
				[17] = 17,
				[18] = 5,
				[19] = 18,
				[20] = 21,
				[21] = 19,
				[22] = 25,
				[23] = 20,
				[24] = 22,
				[25] = 26,
				[26] = 24,
			},
			{
				[1] = 1,
				[2] = 27,
				[3] = 4,
				[4] = 15,
				[5] = 3,
				[6] = 9,
				[7] = 18,
				[8] = 6,
				[9] = 5,
				[10] = 19,
				[11] = 8,
				[12] = 2,
				[13] = 10,
				[14] = 11,
				[15] = 7,
				[16] = 14,
				[17] = 13,
				[18] = 21,
				[19] = 12,
				[20] = 20,
				[21] = 16,
				[22] = 22,
				[23] = 23,
				[24] = 17,
				[25] = 24,
				[26] = 25,
				[27] = 26,
			},
			{
				[1] = 14,
				[2] = 21,
				[3] = 12,
				[4] = 6,
				[5] = 2,
				[6] = 3,
				[7] = 16,
				[8] = 13,
				[9] = 20,
				[10] = 7,
				[11] = 5,
				[12] = 28,
				[13] = 4,
				[14] = 27,
				[15] = 9,
				[16] = 8,
				[17] = 1,
				[18] = 15,
				[19] = 18,
				[20] = 11,
				[21] = 17,
				[22] = 19,
				[23] = 22,
				[24] = 23,
				[25] = 10,
				[26] = 24,
				[27] = 25,
				[28] = 26,
			},
		},
		RMap = {
			{
				[1] = 4,
				[2] = 1,
				[3] = 7,
				[4] = 10,
				[5] = 18,
				[6] = 13,
				[7] = 12,
				[8] = 2,
				[9] = 14,
				[10] = 11,
				[11] = 5,
				[12] = 9,
				[13] = 16,
				[14] = 3,
				[15] = 6,
				[16] = 15,
				[17] = 17,
				[18] = 19,
				[19] = 21,
				[20] = 23,
				[21] = 20,
				[22] = 24,
				[23] = 8,
				[24] = 26,
				[25] = 22,
				[26] = 25,
			},
			{
				[1] = 1,
				[2] = 12,
				[3] = 5,
				[4] = 3,
				[5] = 9,
				[6] = 8,
				[7] = 15,
				[8] = 11,
				[9] = 6,
				[10] = 13,
				[11] = 14,
				[12] = 19,
				[13] = 17,
				[14] = 16,
				[15] = 4,
				[16] = 21,
				[17] = 24,
				[18] = 7,
				[19] = 10,
				[20] = 20,
				[21] = 18,
				[22] = 22,
				[23] = 23,
				[24] = 25,
				[25] = 26,
				[26] = 27,
				[27] = 2,
			},
			{
				[1] = 17,
				[2] = 5,
				[3] = 6,
				[4] = 13,
				[5] = 11,
				[6] = 4,
				[7] = 10,
				[8] = 16,
				[9] = 15,
				[10] = 25,
				[11] = 20,
				[12] = 3,
				[13] = 8,
				[14] = 1,
				[15] = 18,
				[16] = 7,
				[17] = 21,
				[18] = 19,
				[19] = 22,
				[20] = 9,
				[21] = 2,
				[22] = 23,
				[23] = 24,
				[24] = 26,
				[25] = 27,
				[26] = 28,
				[27] = 14,
				[28] = 12,
			},
		},
	},
	PALADIN = {
		VMap = {
			{
				[1] = 1,
				[2] = 10,
				[3] = 5,
				[4] = 7,
				[5] = 14,
				[6] = 3,
				[7] = 9,
				[8] = 4,
				[9] = 8,
				[10] = 6,
				[11] = 25,
				[12] = 15,
				[13] = 2,
				[14] = 11,
				[15] = 16,
				[16] = 13,
				[17] = 18,
				[18] = 12,
				[19] = 17,
				[20] = 21,
				[21] = 19,
				[22] = 20,
				[23] = 26,
				[24] = 24,
				[25] = 22,
				[26] = 23,
			},
			{
				[1] = 9,
				[2] = 18,
				[3] = 13,
				[4] = 4,
				[5] = 12,
				[6] = 24,
				[7] = 10,
				[8] = 3,
				[9] = 25,
				[10] = 11,
				[11] = 2,
				[12] = 8,
				[13] = 5,
				[14] = 14,
				[15] = 6,
				[16] = 26,
				[17] = 7,
				[18] = 15,
				[19] = 1,
				[20] = 16,
				[21] = 20,
				[22] = 17,
				[23] = 19,
				[24] = 23,
				[25] = 22,
				[26] = 21,
			},
			{
				[1] = 3,
				[2] = 4,
				[3] = 10,
				[4] = 8,
				[5] = 1,
				[6] = 12,
				[7] = 6,
				[8] = 9,
				[9] = 13,
				[10] = 11,
				[11] = 19,
				[12] = 14,
				[13] = 5,
				[14] = 15,
				[15] = 2,
				[16] = 16,
				[17] = 25,
				[18] = 7,
				[19] = 17,
				[20] = 18,
				[21] = 21,
				[22] = 22,
				[23] = 20,
				[24] = 26,
				[25] = 23,
				[26] = 24,
			},
		},
		RMap = {
			{
				[1] = 1,
				[2] = 13,
				[3] = 6,
				[4] = 8,
				[5] = 3,
				[6] = 10,
				[7] = 4,
				[8] = 9,
				[9] = 7,
				[10] = 2,
				[11] = 14,
				[12] = 18,
				[13] = 16,
				[14] = 5,
				[15] = 12,
				[16] = 15,
				[17] = 19,
				[18] = 17,
				[19] = 21,
				[20] = 22,
				[21] = 20,
				[22] = 25,
				[23] = 26,
				[24] = 24,
				[25] = 11,
				[26] = 23,
			},
			{
				[1] = 19,
				[2] = 11,
				[3] = 8,
				[4] = 4,
				[5] = 13,
				[6] = 15,
				[7] = 17,
				[8] = 12,
				[9] = 1,
				[10] = 7,
				[11] = 10,
				[12] = 5,
				[13] = 3,
				[14] = 14,
				[15] = 18,
				[16] = 20,
				[17] = 22,
				[18] = 2,
				[19] = 23,
				[20] = 21,
				[21] = 26,
				[22] = 25,
				[23] = 24,
				[24] = 6,
				[25] = 9,
				[26] = 16,
			},
			{
				[1] = 5,
				[2] = 15,
				[3] = 1,
				[4] = 2,
				[5] = 13,
				[6] = 7,
				[7] = 18,
				[8] = 4,
				[9] = 8,
				[10] = 3,
				[11] = 10,
				[12] = 6,
				[13] = 9,
				[14] = 12,
				[15] = 14,
				[16] = 16,
				[17] = 19,
				[18] = 20,
				[19] = 11,
				[20] = 23,
				[21] = 21,
				[22] = 22,
				[23] = 25,
				[24] = 26,
				[25] = 17,
				[26] = 24,
			},
		},
	},
	ROGUE = {
		VMap = {
			{
				[1] = 7,
				[2] = 4,
				[3] = 3,
				[4] = 5,
				[5] = 24,
				[6] = 8,
				[7] = 14,
				[8] = 9,
				[9] = 2,
				[10] = 15,
				[11] = 1,
				[12] = 19,
				[13] = 11,
				[14] = 10,
				[15] = 21,
				[16] = 13,
				[17] = 6,
				[18] = 22,
				[19] = 12,
				[20] = 20,
				[21] = 25,
				[22] = 17,
				[23] = 16,
				[24] = 18,
				[25] = 23,
				[26] = 26,
				[27] = 27,
			},
			{
				[1] = 7,
				[2] = 6,
				[3] = 11,
				[4] = 23,
				[5] = 5,
				[6] = 1,
				[7] = 8,
				[8] = 15,
				[9] = 2,
				[10] = 10,
				[11] = 12,
				[12] = 4,
				[13] = 16,
				[14] = 3,
				[15] = 13,
				[16] = 14,
				[17] = 17,
				[18] = 19,
				[19] = 18,
				[20] = 9,
				[21] = 20,
				[22] = 24,
				[23] = 22,
				[24] = 25,
				[25] = 21,
				[26] = 26,
				[27] = 27,
				[28] = 28,
			},
			{
				[1] = 28,
				[2] = 1,
				[3] = 6,
				[4] = 15,
				[5] = 7,
				[6] = 2,
				[7] = 5,
				[8] = 11,
				[9] = 14,
				[10] = 4,
				[11] = 3,
				[12] = 8,
				[13] = 16,
				[14] = 10,
				[15] = 9,
				[16] = 13,
				[17] = 20,
				[18] = 17,
				[19] = 18,
				[20] = 12,
				[21] = 22,
				[22] = 19,
				[23] = 23,
				[24] = 24,
				[25] = 21,
				[26] = 25,
				[27] = 26,
				[28] = 27,
			},
		},
		RMap = {
			{
				[1] = 11,
				[2] = 9,
				[3] = 3,
				[4] = 2,
				[5] = 4,
				[6] = 17,
				[7] = 1,
				[8] = 6,
				[9] = 8,
				[10] = 14,
				[11] = 13,
				[12] = 19,
				[13] = 16,
				[14] = 7,
				[15] = 10,
				[16] = 23,
				[17] = 22,
				[18] = 24,
				[19] = 12,
				[20] = 20,
				[21] = 15,
				[22] = 18,
				[23] = 25,
				[24] = 5,
				[25] = 21,
				[26] = 26,
				[27] = 27,
			},
			{
				[1] = 6,
				[2] = 9,
				[3] = 14,
				[4] = 12,
				[5] = 5,
				[6] = 2,
				[7] = 1,
				[8] = 7,
				[9] = 20,
				[10] = 10,
				[11] = 3,
				[12] = 11,
				[13] = 15,
				[14] = 16,
				[15] = 8,
				[16] = 13,
				[17] = 17,
				[18] = 19,
				[19] = 18,
				[20] = 21,
				[21] = 25,
				[22] = 23,
				[23] = 4,
				[24] = 22,
				[25] = 24,
				[26] = 26,
				[27] = 27,
				[28] = 28,
			},
			{
				[1] = 2,
				[2] = 6,
				[3] = 11,
				[4] = 10,
				[5] = 7,
				[6] = 3,
				[7] = 5,
				[8] = 12,
				[9] = 15,
				[10] = 14,
				[11] = 8,
				[12] = 20,
				[13] = 16,
				[14] = 9,
				[15] = 4,
				[16] = 13,
				[17] = 18,
				[18] = 19,
				[19] = 22,
				[20] = 17,
				[21] = 25,
				[22] = 21,
				[23] = 23,
				[24] = 24,
				[25] = 26,
				[26] = 27,
				[27] = 28,
				[28] = 1,
			},
		},
	},
};
